Package: LedPred
Title: Learning from DNA to Predict Enhancers
Description: This package aims at creating a predictive model of regulatory
    sequences used to score unknown sequences based on the content of DNA motifs,
    next-generation sequencing (NGS) peaks and signals and other numerical scores of
    the sequences using supervised classification. The package contains a workflow
    based on the support vector machine (SVM) algorithm that maps features to
    sequences, optimize SVM parameters and feature number and creates a model that
    can be stored and used to score the regulatory potential of unknown sequences.
Version: 1.45.0
Date: 2016-08-13
Author: Elodie Darbo, Denis Seyres, Aitor Gonzalez
Maintainer: Aitor Gonzalez <aitor.gonzalez@univ-amu.fr>
Depends: R (>= 3.2.0), e1071 (>= 1.6)
Imports: akima, ggplot2, irr, jsonlite, parallel, plot3D, plyr, RCurl,
        ROCR, testthat
License: MIT | file LICENSE
LazyData: true
Packaged: 2025-10-30 21:42:00 UTC; biocbuild
biocViews: SupportVectorMachine, Software, MotifAnnotation, ChIPSeq,
        Sequencing, Classification
NeedsCompilation: no
BugReports: https://github.com/aitgon/LedPred/issues
RoxygenNote: 5.0.1
git_url: https://git.bioconductor.org/packages/LedPred
git_branch: devel
git_last_commit: f513d31
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30

#.crmFeatureDfToGranges <- function(crm.feature.tab, genome = TRUE) {
#  mat <-
#    matrix(unlist(strsplit(rownames(crm.feature.tab), "_")), nrow = dim(crm.feature.tab)[1], byrow =
#             TRUE)
#  if (genome) {
#    colnames(mat) <- c("genome", "seqnames", "start", "end", "strand")
#  } else {
#    colnames(mat) <- c("seqnames", "start", "end", "strand")
#  }
#  df <- as.data.frame(mat)
#  df[,"start"] <- as.numeric(as.character(df[,"start"]))
#  df[,"end"] <- as.numeric(as.character(df[,"end"]))
#  crm.feature.gr <- GenomicRanges::makeGRangesFromDataFrame(df)
#  GenomicRanges::mcols(crm.feature.gr) <- crm.feature.tab
#  #genome(crm.feature.gr)=mat[1]
#  return(crm.feature.gr)
#}

#' R interface to bed_to_matrix REST in server
#'
#' The \code{mapFeaturesToCRMs} function allows the user to create a training set matrix to build a predictive model. The training set is composed of positive regions (known to be involved in the pathway of interest) and negative regions (randomly picked or known to not be involved in the pathway of interest) that will be described (scored) by features. Three types of features file format are accepted: Position specific scoring matrices modeling motifs recognised by transcription factors, bed files containing region coordinates for any discrete feature (NGS peaks, conservation blocks) and wig/bigWig files containing signal data. This script has been tested with version 0.99 of the online server. Go here to see current version of the server http://ifbprod.aitorgonzalezlab.org/map_features_to_crms.php
#'
#' @param URL URL of the server REST target
#' @param positive.bed Positive bed file path. Compulsory
#' @param genome Genome code, eg. dm3 for Drosophila Melanogaster. Compulsory
#' @param negative.bed Negative bed file path.
#' @param shuffling Integer with number of time shuffle background sequences (background.seqs). If negative.bed is NULL and shuffling is set at 0, the feature matrix does not contain negative sequences. It is useful to produce a test set matrix.
#' @param background.seqs Background sequences used for shuffling. If shuffling = 0, set this parameter at 0.
#' @param genome.info File require for shuffling bed. If shuffling = 0, set this parameter at 0.
#' @param pssm Position specific scoring matrices
#' @param background.freqs Background frequencies of nucleotides in genome
#' @param ngs NGS (bed and wig) files
#' @param bed.overlap Minimal overlap as a fraction of query sequence with NGS bed peak. Equivalent with intersectBed -f argument. Default 1bp.
#' @param my.values Bed file where fourth column are values to append to the SVM matrix
#' @param feature.ranking File with ranked features (Output of rankFeatures). It is used for scoring a query bed file
#' @param feature.nb Integer with feature.nb
#' @param crm.feature.file  Path to feature matrix file
#' @param stdout.log.file  Path to standard output log
#' @param stderr.log.file  Path to error log
#' @return A list
#' \item{feature.matrix}{a data frame where each row is a region and each column a feature, each cell carry a score, the first column is the response vector}
#' \item{stdout.log}{Standard output log of mapFeaturesToCRMs script in server}
#' \item{stderr.log}{Standard error log of mapFeaturesToCRMs script in server}
#' @examples
#' \dontrun{
#'  dirPath <- system.file("extdata", package="LedPred")
#'  file.list <-   list.files(dirPath, full.names=TRUE)
#'  background.freqs <- file.list[grep("freq", file.list)]
#'  positive.regions <-  file.list[grep("positive", file.list)]
#'  negative.regions <-  file.list[grep("negative", file.list)]
#'  TF.matrices <-  file.list[grep("tf", file.list)]
#'  ngs.path <- system.file("extdata/ngs", package="LedPred")
#'  ngs.files=list.files(ngs.path, full.names=TRUE)
#'  crm.features.list <- mapFeaturesToCRMs(positive.bed=positive.regions,
#'      negative.bed=negative.regions,  background.freqs=background.freqs,
#'      pssm=TF.matrices, genome="dm3", ngs=ngs.files,
#'      crm.feature.file = "crm.features.tab",
#'      stderr.log.file = "stderr.log", stdout.log.file = "stdout.log")
#'  names(crm.features.list)
#'  class(crm.features.list$crm.features)
#'  crm.features.list$stdout.log
#'  crm.features.list$stderr.log
#'}

mapFeaturesToCRMs <-
  function(URL = 'http://ifbprod.aitorgonzalezlab.org/map_features_to_crms.php', positive.bed =
             NULL, genome = NULL, negative.bed = NULL, shuffling = NULL, background.seqs =
             NULL, genome.info = NULL, pssm = NULL, background.freqs = NULL, ngs = NULL, bed.overlap =
             NULL, my.values =
             NULL, feature.ranking = NULL, feature.nb = NULL, crm.feature.file = NULL, stderr.log.file =
             NULL, stdout.log.file = NULL) {
message("mapFeaturesToCRMs is running ...")
    postForm.cmd = "RCurl::postForm("
    if (!is.null(URL)) {
      postForm.cmd = paste(postForm.cmd,"uri='",URL,"'", sep = "")
    } else {
      stop("Server URL is missing...")
    }
    
    if (!RCurl::url.exists(URL)) {
      stop('This URL does not exist.')
    }
    
    if (!is.null(positive.bed)) {
      postForm.cmd = paste(
        postForm.cmd,", positive_bed=RCurl::fileUpload(filename = '",positive.bed,"')", sep =
          ""
      )
    } else {
      stop("positive.bed is missing...")
    }
    
    if (!is.null(genome)) {
      postForm.cmd = paste(postForm.cmd,", genome='",genome,"'", sep = "")
    } else {
      #Genome (dm3,mm9...)
      stop("Genome is missing...")
    }
    
    if (!is.null(negative.bed)) {
      postForm.cmd = paste(
        postForm.cmd,", negative_bed=RCurl::fileUpload(filename = '",negative.bed,"')", sep =
          ""
      )
    } else if (!is.null(shuffling)) {
      if (!is.null(shuffling) &&
          !is.null(background.seqs) && !is.null(genome.info)) {
        postForm.cmd = paste(postForm.cmd,", shuffling=",shuffling, sep = "")
        postForm.cmd = paste(
          postForm.cmd,", background_seqs=RCurl::fileUpload(filename = '",background.seqs,"')", sep =
            ""
        )
        postForm.cmd = paste(
          postForm.cmd,", genome_info=RCurl::fileUpload(filename = '",genome.info,"')", sep =
            ""
        )
      } else {
        stop("negative.bed or shuffling/background.seqs/genome_info are missing...")
      }
    } else {
      # no negative -> prediction
      empty.file = tempfile(pattern = "file", tmpdir = tempdir())
      empty.file = gsub("\\\\", "/", empty.file)
      file.create(empty.file)
      postForm.cmd = paste(
        postForm.cmd,", negative_bed=RCurl::fileUpload(filename = '",empty.file,"')", sep =
          ""
      )
    }
    
    if ((!is.null(pssm) &&
         is.null(background.freqs)) &&
        (is.null(pssm) && !is.null(background.freqs))) {
      stop("Both pssm and background.freqs are needed...")
    } else if (!is.null(pssm) && !is.null(background.freqs)) {
      postForm.cmd = paste(postForm.cmd,", pssm=RCurl::fileUpload(filename = '",pssm,"')", sep =
                             "")
      postForm.cmd = paste(
        postForm.cmd,", background_freqs=RCurl::fileUpload(filename = '",background.freqs,"')", sep =
          ""
      )
    }
    
    if (!is.null(ngs)) {
      postForm.cmd.ngs = lapply(ngs, function(x) {
        sprintf("'ngs[]'=RCurl::fileUpload(filename = '%s')", x)
      })
      postForm.cmd.ngs = paste0(unlist(postForm.cmd.ngs), collapse = ",")
      postForm.cmd = paste(postForm.cmd, postForm.cmd.ngs, sep = ",")
      if (!is.null(bed.overlap)) {
        postForm.cmd = paste(postForm.cmd,", f='",bed.overlap,"'", sep = "")
      }
    }
    
    if (!is.null(my.values)) {
      postForm.cmd.my.values = lapply(my.values, function(x) {
        sprintf("'my_values[]'=RCurl::fileUpload(filename = '%s')", x)
      })
      postForm.cmd.my.values = paste0(unlist(postForm.cmd.my.values), collapse =
                                        ",")
      postForm.cmd = paste(postForm.cmd, postForm.cmd.my.values, sep = ",")
    }
    
    if (!is.null(feature.ranking) && !is.null(feature.nb)) {
      feature.ranking.file = tempfile(pattern = "file", tmpdir = tempdir())
      feature.ranking.file = gsub("\\\\", "/", feature.ranking.file)
      write.table(
        feature.ranking, file = feature.ranking.file, quote = FALSE, row.names = FALSE
      )
      postForm.cmd = paste(
        postForm.cmd,", feature_rank=RCurl::fileUpload(filename = '",feature.ranking.file,"')", sep =
          ""
      )
      postForm.cmd = paste(postForm.cmd,", feature_nb=",feature.nb, sep =
                             "")
    }
    
    postForm.cmd = paste(postForm.cmd,", .encoding='utf-8')", sep = "")
    json = eval(parse(text = postForm.cmd))
    json.decoded <- jsonlite::fromJSON(json)
	while (!RCurl::url.exists(json.decoded[['stdoutLog']])) { Sys.sleep(5) }
	match=FALSE
	while (!match){ Sys.sleep(5); data=readLines(json.decoded[['stdoutLog']]); match=any(grepl('Finished', data)) };
    crm.feature.tab <-
      read.table(json.decoded$crmFeatures, fill = TRUE)
#    crm.feature.gr <- .crmFeatureDfToGranges(crm.feature.tab)
    stdout.log = RCurl::getURL(json.decoded$stdoutLog)
    stderr.log = RCurl::getURL(json.decoded$stderrLog)
    if (!is.null(crm.feature.file)) {
      write.table(crm.feature.tab, file = crm.feature.file, quote = FALSE, col.names=NA, sep="\t")
    }
    if (!is.null(stdout.log.file)) {
      download.file(json.decoded$stdoutLog, destfile = stdout.log.file)
    }
    if (!is.null(stderr.log.file)) {
      download.file(json.decoded$stderrLog, destfile = stderr.log.file)
    }
    return(
      list(
        crm.features = crm.feature.tab, stdout.log = stdout.log, stderr.log = stderr.log
      )
    )
  }

FeatureRanking <- R6::R6Class(
  "FeatureRanking",
  inherit = ParameterTuner,
  public = list(
    kfold.nb = 1,
    halve.above = 100,
    feature.ranking = NULL,
    initialize = function(x, y, kernel = self$kernel, cost = self$cost, gamma =
                            self$gamma, valid.times = self$valid.times, kfold.nb =
                            self$kfold.nb, halve.above = self$halve.above, numcores = self$numcores, file.prefix =
                            self$file.prefix) {
      if (!missing(kernel))
        self$kernel = kernel
      if (!missing(cost))
        self$cost = cost
      if (!missing(gamma))
        self$gamma = gamma
      if (!missing(valid.times)) {
        self$valid.times = valid.times
        parent.obj = ParameterTuner$new(x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma, valid.times = self$valid.times)
      } else {
        parent.obj = ParameterTuner$new(x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma)
      }
      self$x = parent.obj$x
      self$y = parent.obj$y
      self$test.folds = parent.obj$test.folds
      self$cost = parent.obj$cost
      self$gamma = parent.obj$gamma
      if (!missing(file.prefix))
        self$file.prefix = file.prefix
      if (!missing(kfold.nb))
        self$kfold.nb = kfold.nb
      if (!missing(numcores))
        self$numcores = numcores
      if (.Platform$OS.type == "windows") self$numcores = 1
      if (!missing(halve.above))
        self$halve.above = halve.above
      self$feature.ranking = private$RankFeatures(self$x, self$y, self$test.folds, self$halve.above)
      if (!is.null(self$file.prefix))
        write.table(
          self$feature.ranking, file = paste(file.prefix, '_feature_ranking.txt', sep =
                                               ""), quote = FALSE, row.names = FALSE
        )
    }
  ),
  private = list(
    probability = TRUE,
    decision.values = TRUE,
    RankFeatures = function (x, y, test.folds, halve.above) {
    message("rankFeatures is running ...")
      feature.ranking_results = parallel::mclapply(
        test.folds, private$RunSVMRFEOneFold, x = x, y = y, mc.cores = self$numcores, mc.set.seed = FALSE
      )
      
      featureID = sort(apply(sapply(feature.ranking_results, function(x)
        sort(x$feature, index.return = TRUE)$ix), 1, mean), index = TRUE)$ix
      avg.rank  = sort(apply(sapply(feature.ranking_results, function(x)
        sort(x$feature, index.return = TRUE)$ix), 1, function (x)
          round(mean(x),5)), index = TRUE)$x
      feature.name = colnames(x)[featureID]
      feature.ranking = data.frame(FeatureName = feature.name, FeatureID = featureID, AvgRank =
                                     avg.rank)
      feature.ranking = feature.ranking[with(feature.ranking, order(AvgRank, FeatureName)),]
      return(feature.ranking)
    },
    RunSVMRFEOneFold = function (test.fold.i, x, y, halve.above = 100) {
      train.fold.i = (1:nrow(x))[!(1:nrow(x) %in% test.fold.i)]
      x = x[train.fold.i,]
      y = y[train.fold.i]
      set.seed(123)
      k.folds = rep(1:self$kfold.nb, len = nrow(x))[sample(nrow(x))]
      k.folds = lapply(1:self$kfold.nb, function(x)
        which(k.folds == x))
      
      feature.ids = private$RunSVMRFE(x, y, k.folds, halve.above)
      return(
        list(
          feature.ids = feature.ids, train.data.ids = train.fold.i, test.data.ids = test.fold.i
        )
      )
    },
    RunSVMRFE = function(x, y, k.folds, halve.above = 100) {
      n = ncol(x)
      i.surviving = 1:n
      i.ranked    = n
      ranked.list = vector(length = n)
      
      x.rfe = x
      
      # ---------------------
      while (length(i.surviving) > 1) {
        k.fold.weights = lapply(k.folds, private$GetKFoldWeights, x = x.rfe, y =
                                  y)
        
        c = private$CombineKFoldWeigths(k.fold.weights)
        ranking = sort(c, index.return = TRUE)$ix
        
        if (length(i.surviving) > halve.above) {
          # Cut features in half until less than halve.above
          nfeat = length(i.surviving)
          ncut  = round(nfeat / 2)
          n     = nfeat - ncut
        } else
          ncut = 1
        
        ranked.list[i.ranked:(i.ranked - ncut + 1)] = i.surviving[ranking[1:ncut]]
        i.ranked    = i.ranked - ncut
        i.surviving = i.surviving[-ranking[1:ncut]]
        
        x.rfe = x[,i.surviving]
      }
      
      ranked.list[1] = i.surviving # add latest i.surviving
      # ---------------------
      return(ranked.list)
    },
    CombineKFoldWeigths = function (w) {
      if (length(w) > 1) {
        w = do.call(rbind, w)
        
        # Normalize each weights vector
        w = t(apply(w, 1, function(x)
          x / sqrt(sum(x ^ 2))))
        
        # Compute ranking criteria
        v    = w ^ 2
        vbar = apply(v, 2, mean)
        vsd  = apply(v, 2, sd)
        c    = vbar / vsd
      } else {
        c = unlist(w) ^ 2
      }
      return(c)
    },
    GetKFoldWeights = function(k.fold.i, x, y) {
      x = x[k.fold.i,]
      y = y[k.fold.i]
      obj <-
        Model$new(
          x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma, valid.times = 1
        )
      
      return(obj$weights)
    }
  )
)

LedPredClass <- R6::R6Class(
  "LedPredClass",
  inherit = ParameterTuner,
  public = list(
    kfold.nb = 1,
    halve.above = 100,
    feature.ranking = NULL,
    feature.nb.vector = NULL,
    feature.performances = NULL,
    best.feature.nb = NULL,
    model = NULL,
    model.obj = NULL,
    weights = NULL,
    cv.probs.labels = NULL,
    ranges = list(gamma=c(1,10), cost=c(1,10)),
    initialize = function(x, y, valid.times = self$valid.times, kfold.nb =
                            self$kfold.nb, halve.above = self$halve.above, numcores = self$numcores, file.prefix =
                            self$file.prefix, feature.nb.vector, cost=self$cost, gamma=self$gamma, ranges = self$ranges, kernel=self$kernel) {
      #
      if (!missing(kernel))
        self$kernel = kernel
      if (!missing(cost))
        self$cost = cost
      if (!missing(gamma))
        self$gamma = gamma
      if (!missing(valid.times)) {
        self$valid.times = valid.times
        parent.obj = ParameterTuner$new(x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma, valid.times = self$valid.times)
      } else {
        parent.obj = ParameterTuner$new(x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma)
      }
      self$x = parent.obj$x
      self$y = parent.obj$y
      self$test.folds = parent.obj$test.folds
      self$cost = parent.obj$cost
      self$gamma = parent.obj$gamma
      if (!missing(file.prefix))
        self$file.prefix = file.prefix
      if (!missing(kfold.nb))
        self$kfold.nb = kfold.nb
      if (!missing(numcores))
        self$numcores = numcores
      if (!missing(halve.above))
        self$halve.above = halve.above
      #
      feature.ranking.obj <-
        FeatureRanking$new(
          x, y, valid.times = self$valid.times, kfold.nb = self$kfold.nb, halve.above =
            self$halve.above, numcores = self$numcores, file.prefix = file.prefix, cost=self$cost, gamma=self$gamma, kernel=self$kernel
        )
      self$feature.ranking = feature.ranking.obj$feature.ranking
      #
      if (!missing(feature.nb.vector))
        self$feature.nb.vector = feature.nb.vector
      #
      feature.nb.tuner.obj <-
        FeatureNbTuner$new(
          x = self$x, y = self$y, valid.times = self$valid.times, numcores = self$numcores, feature.ranking =
            self$feature.ranking, feature.nb.vector = self$feature.nb.vector, file.prefix =
            self$file.prefix, cost=self$cost, gamma=self$gamma, kernel=self$kernel
        )
      self$feature.performances = feature.nb.tuner.obj$feature.performances
      self$best.feature.nb = feature.nb.tuner.obj$best.feature.nb
      #
      model.perf.obj = ModelPerformance$new(
        x = x, y = y, feature.ranking = self$feature.ranking, feature.nb = self$best.feature.nb, file.prefix =
          self$file.prefix, cost=self$cost, gamma=self$gamma, kernel=self$kernel, numcores = self$numcores
      )
      self$model = model.perf.obj$model
      self$model.obj = model.perf.obj$model.obj
      self$weights = model.perf.obj$weights
      self$cv.probs.labels = model.perf.obj$cv.probs.labels
      if (!is.null(self$file.prefix))
        save(self, file = paste(file.prefix, '_ledpred.rda', sep = ""))
      #
      #    print(self$feature.ranking)
      #    print(self$best.feature.nb)
      #    print(rownames(self$model$SV)[1:3])
      #    print(self$cv.probs.labels$probs[1,1])
    }
  )
)

FeatureNbTuner <- R6::R6Class(
  "FeatureNbTuner",
  inherit = ParameterTuner,
  public = list(
    feature.ranking = NULL,
    feature.nb.vector = NULL,
    feature.performances = NULL,
    best.feature.nb = NULL,
    initialize = function(x, y, kernel = self$kernel, cost = self$cost, gamma =
                            self$gamma, valid.times = self$valid.times, numcores =
                            self$numcores, feature.ranking, feature.nb.vector, file.prefix = self$file.prefix) {
      if (!missing(kernel))
        self$kernel = kernel
      if (!missing(cost))
        self$cost = cost
      if (!missing(gamma))
        self$gamma = gamma
      if (!missing(valid.times)) {
        self$valid.times = valid.times
        parent.obj = ParameterTuner$new(x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma, valid.times = self$valid.times)
      } else {
        parent.obj = ParameterTuner$new(x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma)
      }
      self$x = parent.obj$x
      self$y = parent.obj$y
      self$test.folds = parent.obj$test.folds
      self$cost = parent.obj$cost
      self$gamma = parent.obj$gamma
      if (!missing(file.prefix))
        self$file.prefix = file.prefix
      if (!missing(numcores))
        self$numcores = numcores
      if (!missing(feature.nb.vector))
        self$feature.nb.vector = feature.nb.vector
      self$feature.ranking = feature.ranking
      ranked.features = as.character(self$feature.ranking$FeatureName)
      self$feature.performances = private$FeatureKappaPerformance(
        feature.nb.vector = self$feature.nb.vector, ranked.features = ranked.features, test.folds =
          self$test.folds, x = self$x, y = self$y
      )
      kappa.vector = simplify2array(self$feature.performances["cv.kappa.mean",])
      self$best.feature.nb = self$feature.nb.vector[min(which(kappa.vector == max(kappa.vector)))][[1]]
      if (!is.null(self$file.prefix))
        write(self$best.feature.nb, file = paste(file.prefix, "_best.feature.nb.txt", sep =
                                                   ""))
      private$PlotKappa(feature_nb_obj, file.prefix)
    }
  ),
  private = list(
    PlotKappa = function(feature_nb_obj, file.prefix) {
      feature.nb.vector = simplify2array(self$feature.nb.vector)
      cv.kappa.mean = simplify2array(self$feature.performances["cv.kappa.mean",])
      cv.kappa.sd = simplify2array(self$feature.performances["cv.kappa.sd",])
      best.feature.nb = self$best.feature.nb
      png()
      ggplot2::qplot(feature.nb.vector,cv.kappa.mean) + ggplot2::geom_errorbar(
        ggplot2::aes(
          x = feature.nb.vector, ymin = cv.kappa.mean - cv.kappa.sd, ymax = cv.kappa.mean +
            cv.kappa.sd
        ), width = 0.25
      ) + ggplot2::geom_line()
      ggplot2::ggsave(paste(file.prefix, "_kappa_measures.png", sep = ""));
      garb = dev.off()
    },
    FeatureKappaPerformance = function(feature.nb.vector, ranked.features, test.folds, x, y) {
    
      message("tuneFeatureNb is running ...")
      
      feature.performances = simplify2array(parallel::mclapply(feature.nb.vector, function(feature.nb) {
        x.features = x[, ranked.features[1:feature.nb]];  private$CalcKappaPerformanceAllFoldMean(test.folds =
                                                                                                    test.folds, x = x.features, y = y)
      }, mc.cores = self$numcores))
      return(feature.performances)
    },
    CalcKappaPerformanceAllFoldMean = function(test.folds, x, y) {
      cv.kappa = simplify2array(parallel::mclapply(test.folds, function(test.fold.i) {
        private$CalcKappaPerformanceOneFold(x = x, y = y, test.fold.i = test.fold.i)
      }, mc.cores = self$numcores))
      cv.kappa.mean = mean(cv.kappa);
      cv.kappa.sd = sd(cv.kappa);
      return(list(cv.kappa.mean = cv.kappa.mean, cv.kappa.sd = cv.kappa.sd));
    },
    CalcKappaPerformanceOneFold = function(test.fold.i, x, y) {
      test.set.x = x[test.fold.i,]
      test.set.y = y[test.fold.i]
      train.set.x = x[-test.fold.i,]
      train.set.y = y[-test.fold.i]
      model.obj = Model$new(
        x = train.set.x, y = train.set.y, kernel = self$kernel, cost = self$cost, gamma =
          self$gamma, valid.times = 1
      )
      kappa = model.obj$CalcPredictionKappa(x = test.set.x, y = test.set.y)
      return(kappa)
    }
  )
)

.classAgreement2 <- function (tab) {
  n <- sum(tab)
  # correct classification rate
  if (!is.null(dimnames(tab))) {
    lev <- intersect(colnames(tab), rownames(tab))
    d <- diag(tab[lev, lev])
    p0 <- sum(d) / n
  } else {
    m <- min(dim(tab))
    d <- diag(tab[1:m, 1:m])
    p0 <- sum(d) / n
  }
  p0 <- list(p0 = p0)
  if (is.null(dimnames(tab))) {
    stop('tables without dimension names are not allowed when generating confusionmatrizes.')
  }
  return(p0)
}


.plotCostGamma <- function(e1071.tune.obj) {
  c.g.perf <- e1071.tune.obj$performances
  if (length(e1071.tune.obj$best.parameter) == 1) {
    c.g.perf[,"gamma"] <- 1:nrow(c.g.perf)
  }
  
  xyz = akima::interp(c.g.perf$cost, c.g.perf$gamma, c.g.perf$error)
  p = plot3D::image2D(
    xyz$z, x = xyz$x, y = xyz$y, facets = FALSE, log = "xy",
    xlim = c(min(xyz$x[which(xyz$x > 0)]), max(x = xyz$x)),
    ylim = c(min(xyz$y[which(xyz$y > 0)]), max(x = xyz$y)),
    xlab = "cost", ylab = "gamma"
  )
  cost = e1071.tune.obj$best.parameters$cost
  gamma = e1071.tune.obj$best.parameters$gamma
  title(paste("best cost:", cost,' and gamma:', gamma))
  points (c.g.perf$cost,c.g.perf$gamma, pch = "x", cex = 2)
}

ParameterTuner <- R6::R6Class(
  "ParameterTuner",
  inherit = Data,
  public = list(
    ranges = list(gamma=c(1,10), cost=c(1,10)),
    e1071.tune.obj = NULL,
    initialize = function(x, y, kernel = self$kernel, cost = self$cost, gamma =
                            self$gamma, valid.times=self$valid.times, ranges = self$ranges, numcores=self$numcores, file.prefix=self$file.prefix) {
      if (!missing(kernel))
        self$kernel = kernel
      if (!missing(cost))
        self$cost = cost
      if (!missing(gamma))
        self$gamma = gamma
      if (!missing(ranges)) self$ranges = ranges
      if (!missing(numcores)) self$numcores = numcores
      if (!missing(file.prefix)) self$file.prefix = file.prefix
      if (!missing(valid.times)) {
        self$valid.times = valid.times
        parent.obj = Data$new(x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma, valid.times = self$valid.times)
      } else {
        parent.obj = Data$new(x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma)
      }
      self$x = parent.obj$x
      self$y = parent.obj$y
      self$test.folds = parent.obj$test.folds
      self$cost = parent.obj$cost
      self$gamma = parent.obj$gamma
      self$scale.factors = parent.obj$scale.factors
if (is.null(self$cost) || (self$kernel=='radial' && is.null(self$gamma))) {
	self$e1071.tune.obj = private$mcTune()
	self$cost = self$e1071.tune.obj$best.parameters$cost
	self$gamma = self$e1071.tune.obj$best.parameters$gamma
	}
  }
  ),
  private = list(
      mcTune = function(y=self$y, x=self$x, valid.times=self$valid.times, numcores=self$numcores, ranges=self$ranges, file.prefix=self$file.prefix) {

  message("mcTune is running ...")
  call <- match.call()
  
#  if (!is.null(data.granges)) {
#    data = .crmFeaturesToDf(data.granges)
#  }
  
  
  ## Set the method to be tuned
  method <- 'svm'
  ## Set control method to tune.control() from e1071 package
  
  tunecontrol <-
    e1071::tune.control(sampling = "cross", cross = valid.times)
    
#  cl <- as.factor(as.vector(data[,cl]))
  cl <- y
  
#  train.x <- cl ~ .
  train.x <- x
  useFormula = TRUE
  

  # Set the method to predict
  predict.func <- predict
  
  
  ## prepare training indices  
#  browser()
#  train.ind <- .makeCrossValidSets(data, valid.times)
train.folds<-lapply(1:length(self$test.folds), function(xi) (1:nrow(x))[-self$test.folds[[xi]]])

  parameters <- (if (is.null(self$ranges))
    data.frame(dummyparameter = 0)
    else
      expand.grid(self$ranges))
  p <- nrow(parameters)

  if (!is.logical(tunecontrol$random)) {
    if (tunecontrol$random < 1)
      stop("random must be a strictly positive integer")
    if (tunecontrol$random > p)
      tunecontrol$random <- p
    parameters <- parameters[sample(1:p, tunecontrol$random),]
  }

#mctune function ------------------------------------
  train_results <-
    do.call(
      what = get("mclapply", asNamespace("parallel")), args = c(mc.cores = self$numcores, list(
        X = 1:p, FUN = function(para.set) {
          sampling.errors <- c()
          sampling.confusions <- c()
          ## - loop over all training samples
          for (sample in 1:length(train.folds)) {
            repeat.errors <- c()
            repeat.confusions <- c()
            
            ## - repeat training `nrepeat' times
            for (reps in 1:tunecontrol$nrepeat) {
              #        print(ranges)
              

              ## train one model
              pars <- if (is.null(ranges))
                NULL
              else
                lapply(parameters[para.set,,drop = FALSE], unlist)
                train.fold.i <- train.folds[[sample]]
	            model.obj <- Model$new(x = self$x[train.fold.i,], y = self$y[train.fold.i], kernel=self$kernel, cost=pars$cost, gamma=pars$gamma)
                model <- model.obj$model
              ## predict validation set
              
              
              pred <-
                predict.func(model,x[-train.folds[[sample]],])
              ## compute performance measure
#              true.y <- .resp(train.x, data[-train.folds[[sample]],])
              true.y <- self$y[-train.folds[[sample]]]
              
              if (is.null(true.y))
                true.y <- rep(TRUE, length(pred))
              
              if (!is.null(tunecontrol$error.fun))
                repeat.errors[reps] <-
                tunecontrol$error.fun(true.y, pred)
              else if ((is.logical(true.y) ||
                       (is.logical(pred) ||
                        is.factor(true.y)) &&
                        is.factor(pred) || is.character(pred))) {
                ## classification error
                l <- .classAgreement2(table(pred, true.y))
                repeat.errors[reps] <-
                  (1 - l$p0) # wrong classification rate
              } else if (is.numeric(true.y) &&
                         is.numeric(pred))
                ## mean squared error
                repeat.errors[reps] <-
                crossprod(pred - true.y) / length(pred)
              else
                stop("Dependent variable has wrong type!")
            }
            
            sampling.errors[sample] <-
              tunecontrol$repeat.aggregate(repeat.errors)
            
          }
          list(
            model.error = tunecontrol$sampling.aggregate(sampling.errors),
            model.variance = tunecontrol$sampling.dispersion(sampling.errors)
          )
        }
      ))
    )
    
  model.errors <-
    unlist(lapply(train_results,function(x)
      x$model.error))
  model.variances <-
    unlist(lapply(train_results,function(x)
      x$model.variance))
  
  ## return results
  best <- which.min(model.errors)
  pars <- if (is.null(ranges))
    NULL
  else
    lapply(parameters[best,,drop = FALSE], unlist)
  e1071.tune.obj <-
    structure(
      list(
        best.parameters  = parameters[best,,drop = FALSE],
        best.performance = model.errors[best],
        method           = "svm",
        nparcomb         = nrow(parameters),
        train.ind        = train.folds,
        sampling         = switch(
          tunecontrol$sampling,
          fix = "fixed training/validation set",
          bootstrap = "bootstrapping",
          cross = if (tunecontrol$cross == nrow(self$x))
            "leave-one-out"
          else
            paste(tunecontrol$cross,"-fold cross validation", sep ="")
        ),
        performances     = if (tunecontrol$performances)
          cbind(parameters, error = model.errors, dispersion = model.variances),
        best.model       = if (tunecontrol$best.model) {
                modeltmp <- e1071::svm(y=self$y, x=self$x, scale = self$scale, kernel = self$kernel, type="C-classification", cost=parameters[best,,drop = FALSE]$cost, gamma=parameters[best,,drop = FALSE]$gamma)
          modeltmp
        }
      ),
      class = "tune"
    )
  if (!is.null(file.prefix)) {
    png(paste(file.prefix,"_c_g_eval.png",sep = ""))
    .plotCostGamma(e1071.tune.obj)
    garb = dev.off()
  }
return(e1071.tune.obj)
    }
      )
)

### R code from vignette source 'LedPred.Rnw'

###################################################
### code chunk number 1: crm.features
###################################################
library(LedPred)
data(crm.features)


###################################################
### code chunk number 2: mapFeaturesToCRMs
###################################################
dirPath <- system.file("extdata", package="LedPred")
file.list <-   list.files(dirPath, full.names=TRUE)
background.freq <- file.list[grep("freq", file.list)]
positive.regions <-  file.list[grep("positive", file.list)]
negative.regions <-  file.list[grep("negative", file.list)]
TF.matrices <-  file.list[grep("tf", file.list)]
ngs.path <- system.file("extdata/ngs", package="LedPred")
ngs.files=list.files(ngs.path, full.names=TRUE)
#crm.feature.list <- mapFeaturesToCRMs(URL = 'http://ifbprod.aitorgonzalezlab.org/map_features_to_crms.php', positive.bed=positive.regions, negative.bed=negative.regions, background.freqs=background.freq, pssm=TF.matrices, genome="dm3", ngs=ngs.files,  crm.feature.file = "vignette_crm.features.tab",  stderr.log.file = "vignette_stderr.log", stdout.log.file = "vignette_stdout.log")
#names(crm.feature.list)
#class(crm.feature.list$crm.features)


###################################################
### code chunk number 3: mcTune
###################################################
#crm.features=crm.feature.list$crm.features
#cost.vector <- c(1,3,10)
#gamma.vector <- c(1,3,10)
#c.g.obj <- mcTune(data = crm.features, ranges = list(cost=cost.vector, gamma=gamma.vector), kernel='linear', file.prefix = "vignette")
#names(c.g.obj)
#cost <- c.g.obj$e1071.tune.obj$best.parameters$cost
#gamma <- c.g.obj$e1071.tune.obj$best.parameters$gamma


###################################################
### code chunk number 4: LedPred.Rnw:170-172
###################################################
#feature.ranking <- rankFeatures(data=crm.features, cost=cost, gamma=gamma, kernel='linear', file.prefix = "vignette")
#head(feature.ranking)


###################################################
### code chunk number 5: LedPred.Rnw:178-181
###################################################
#feature.nb.tuner.obj <- tuneFeatureNb(data=crm.features, feature.ranking=feature.ranking, kernel='linear', cost=cost, gamma=gamma, file.prefix = "vignette")
#names(feature.nb.tuner.obj)
#feature.nb.tuner.obj$best.feature.nb


###################################################
### code chunk number 6: LedPred.Rnw:193-197
###################################################
#feature.nb <- 60
#model.obj <- createModel(data=crm.features, cost=cost, gamma=gamma, feature.ranking=feature.ranking, feature.nb=feature.nb, file.prefix="vignette")
#names(model.obj)
#model.obj$model


###################################################
### code chunk number 7: LedPred.Rnw:202-204
###################################################
#feature.weights <- as.data.frame(t(t(model.obj$model$coefs) %*% model.obj$model$SV))
#head(feature.weights)


###################################################
### code chunk number 8: LedPred.Rnw:210-211
###################################################
#probs.labels.list <- evaluateModelPerformance(data=crm.features, feature.ranking=feature.ranking, feature.nb=feature.nb, cost=cost, gamma=gamma, file.prefix = "vignette")


###################################################
### code chunk number 9: mapFeaturesToCRMs2
###################################################
dirPath <- system.file("extdata", package="LedPred")
file.list <-   list.files(dirPath, full.names=TRUE)
background.freqs <- file.list[grep("freq", file.list)]
positive.bed <-  file.list[grep("prediction_small", file.list)]
TF.matrices <-  file.list[grep("259_matrices_lightNames", file.list)]
ngs.path <- system.file("extdata/ngs", package="LedPred")
ngs.files=list.files(ngs.path, full.names=TRUE)
#prediction.crm.features.list <- mapFeaturesToCRMs(URL = 'http://ifbprod.aitorgonzalezlab.org/map_features_to_crms.php', positive.bed=positive.bed, 
#  pssm=TF.matrices, background.freqs=background.freqs, 
#  genome='dm3', ngs=ngs.files, feature.ranking=feature.ranking, feature.nb=feature.nb, 
#    crm.feature.file = "vignette_pred.crm.features.tab", 
#    stderr.log.file = "vignette_pred.stderr.log", stdout.log.file = "vignette_pred.stdout.log")
#names(prediction.crm.features.list)
#prediction.crm.features <- prediction.crm.features.list$crm.features


###################################################
### code chunk number 10: scoreData
###################################################
#pred.test <- scoreData(data=prediction.crm.features, model=model.obj, score.file="vignette_prediction.tab")
#pred.test


###################################################
### code chunk number 11: ledpred
###################################################
crm.features=data(crm.features)
cost.vector <- c(1,3,10)
gamma.vector <- c(1,3,10)
#ledpred.obj=LedPred(data=crm.features, cl=1, ranges = list(cost=cost.vector, gamma=gamma.vector), kernel="linear", file.prefix="vignette2")
#names(ledpred.obj)


###################################################
### code chunk number 12: mapFeaturesToCRMs3
###################################################
dirPath <- system.file("extdata", package="LedPred")
file.list <-   list.files(dirPath, full.names=TRUE)
background.freqs <- file.list[grep("freq", file.list)]
positive.bed <-  file.list[grep("prediction_small", file.list)]
TF.matrices <-  file.list[grep("259_matrices_lightNames", file.list)]
ngs.path <- system.file("extdata/ngs", package="LedPred")
ngs.files=list.files(ngs.path, full.names=TRUE)
#prediction.crm.features.obj2 <- mapFeaturesToCRMs(URL = 'http://ifbprod.aitorgonzalezlab.org/map_features_to_crms.php', positive.bed=positive.bed, 
#  pssm=TF.matrices, background.freqs=background.freqs, 
#  genome='dm3', ngs=ngs.files, feature.ranking=ledpred.obj$feature.ranking, feature.nb=ledpred.obj$feature.nb, 
#    crm.feature.file = "vignette2_pred.crm.features.tab", 
#    stderr.log.file = "vignette2_pred.stderr.log", stdout.log.file = "vignette2_pred.stdout.log")
#names(prediction.crm.features.obj2)
#prediction.crm.features2 <- prediction.crm.features.obj2$crm.features


###################################################
### code chunk number 13: scoreData2 (eval = FALSE)
###################################################
## #pred.test2 <- scoreData(data=prediction.crm.features2, model=ledpred.list$model.obj, score.file="vignette2_prediction.tab")
## #pred.test2


###################################################
### code chunk number 14: LedPred.Rnw:290-291
###################################################
sessionInfo()

Model <- R6::R6Class(
  "Model",
  inherit = ParameterTuner,
  public = list(
    model = NULL,
    weights = NULL,
    feature.ranking = NULL,
    feature.nb = NULL,
    initialize = function(x, y, kernel = self$kernel, cost = self$cost, gamma =
                            self$gamma, valid.times = self$valid.times, feature.ranking = self$feature.ranking, feature.nb =
                            self$feature.nb, file.prefix = self$file.prefix) {
      #      self$x = x
      #      self$y = y
      if (!is.null(feature.ranking) && !is.null(feature.nb)) {
        self$feature.ranking = feature.ranking
        self$feature.nb = feature.nb
        selected.features = as.character(self$feature.ranking$FeatureName[1:self$feature.nb])
        x = x[,selected.features]
      }
      if (!missing(kernel))
        self$kernel = kernel
      if (!missing(cost))
        self$cost = cost
      if (!missing(gamma))
        self$gamma = gamma
      if (!missing(valid.times)) {
        self$valid.times = valid.times
        parent.obj = ParameterTuner$new(x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma, valid.times = self$valid.times)
      } else {
        parent.obj = ParameterTuner$new(x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma)
      }
      self$x = parent.obj$x
      self$y = parent.obj$y
      self$test.folds = parent.obj$test.folds
      self$cost = parent.obj$cost
      self$gamma = parent.obj$gamma
      self$scale.factors = parent.obj$scale.factors
#      self$scale.center = data.obj$scale.center #store scale center
#      self$scale.scale = data.obj$scale.scale #store scale scale
      self$file.prefix = file.prefix
      private$CreateModel()
      self$weights = (t(self$model$coefs) %*% self$model$SV)
      if (!is.null(self$file.prefix))
        save(self, file = paste(file.prefix,"_model.rda",sep = "")) # can save model for later use
    },
    ScoreData = function(x, scale=TRUE) {
      if (!is.null(self$feature.ranking) && !is.null(self$feature.nb)) {
        selected.features = as.character(self$feature.ranking$FeatureName[1:self$feature.nb])
        x = x[,selected.features]
      }
      if (scale) {
      x=t(t(x)/self$scale.factors)
      }
#      x = scale(x, center = self$scale.center, scale = self$scale.scale)
      library(e1071)
      classpred = predict(
        self$model, x, decision.values = private$decision.values, probability = private$probability
      )
      probs = attr(classpred,"probabilities")[,c("1")]
      scores = attr(classpred,"decision.values")[,1]
      if (colnames(attr(classpred,"decision.values"))=="-1/1") # predicts inverse: needs negative
        scores = -scores
      return(list(
        probs = probs, scores = scores, prediction = classpred
      ))
    },
    CalcPredictionKappa = function(x, y, scale=FALSE) {
      prediction = self$ScoreData(x = x, scale=scale)$prediction
      return(irr::kappa2(cbind(y, prediction))$value)
    }
  ),
  private = list(
    probability = TRUE,
    decision.values = TRUE,
    CreateModel = function() {
      set.seed(123)
      if (self$kernel=="linear")
      self$model = e1071::svm(
        x = self$x, y = self$y, type = private$type, kernel = self$kernel, cost = self$cost, scale = private$scale, probability =
          private$probability, decision.values = private$decision.values,
        cachesize = 500
      ) 
      else if (self$kernel=="radial")
      self$model = e1071::svm(
        x = self$x, y = self$y, type = private$type, kernel = self$kernel, cost = self$cost, gamma = self$gamma, scale = private$scale, probability =
          private$probability, decision.values = private$decision.values,
        cachesize = 500
      ) 
    }
  )
)

#source("Model.R")

ModelPerformance <- R6::R6Class(
  "ModelPerformance",
  inherit = Model,
  public = list(
    model.obj = NULL,
    cv.probs.labels = NULL,
    auc = NULL,
    initialize = function(x, y, kernel = self$kernel, cost = self$cost, gamma =
                            self$gamma, valid.times = self$valid.times, numcores = self$numcores, file.prefix =
                            self$file.prefix, feature.ranking = self$feature.ranking, feature.nb = self$feature.nb) {
      if (!missing(kernel))
        self$kernel = kernel
      if (!missing(cost))
        self$cost = cost
      if (!missing(gamma))
        self$gamma = gamma
      if (!missing(valid.times))
        self$valid.times = valid.times
      if (!missing(numcores))
        self$numcores = numcores
      if (!missing(feature.ranking))
        self$feature.ranking = feature.ranking
      if (!missing(feature.nb))
        self$feature.nb = feature.nb
      if (!missing(file.prefix))
        self$file.prefix = file.prefix
      self$model.obj = Model$new(
        x = x, y = y, kernel = self$kernel, cost = self$cost, gamma = self$gamma, valid.times = self$valid.times, feature.ranking =
          self$feature.ranking, feature.nb = self$feature.nb, file.prefix = self$file.prefix
      )
      self$x = self$model.obj$x
      self$y = self$model.obj$y
      self$test.folds = self$model.obj$test.folds
      self$model = self$model.obj$model
      self$weights = self$model.obj$weights
      self$cv.probs.labels = private$CVModelPeformanceAllFolds(test.folds = self$test.folds)
      png(paste(self$file.prefix,"_ROC_perf.png", sep = ""))
      private$PlotROCR(
        labels = self$cv.probs.labels$labels, probs = self$cv.probs.labels$probs, rocr.pred = self$cv.probs.labels$rocr.pred
      )
      garb = dev.off()
    },
    Tests = function() {
      probs = private$CVModelPeformanceOneFold(test.fold.i = self$test.folds[[1]])$probs
      testthat::expect_equal(probs[[1]], 0.9748439, tolerance = 10 - 9)
    }
  ),
  private = list(
    CVModelPeformanceOneFold = function(test.fold.i = test.fold.i) {
      test.set.x = self$x[test.fold.i,]
      train.set.x = self$x[-test.fold.i,]
      test.set.y = self$y[test.fold.i]
      train.set.y = self$y[-test.fold.i]
      
      # Remove empty features because it triggers model errror
      if (any(apply(train.set.x==0,2,all))) {
        warning("Some features in this fold are zero everywhere and must be removed")
        train.set.x = train.set.x[, !apply(train.set.x==0,2,all)]
        test.set.x = test.set.x[, colnames(train.set.x)]
      }
      # End of - Remove empty features because it triggers model errror
      
      obj <-
        Model$new(
          x = train.set.x, y = train.set.y, kernel = self$kernel, cost = self$cost, gamma =
            self$gamma, valid.times = 5
        )
      probs = obj$ScoreData(x = test.set.x, scale=FALSE)$probs
      return(list(probs = probs, labels = test.set.y))
    },
    CVModelPeformanceAllFolds = function(test.folds = test.folds) {
    message("evaluateModelPerformance is running ...")
      cv.probs.labels = parallel::mclapply(test.folds, private$CVModelPeformanceOneFold, mc.cores =
                                             self$numcores)
      labels = sapply(cv.probs.labels, function(x)
        x$labels)
      probs = sapply(cv.probs.labels, function(x)
        x$probs)
        #Calculate AUC using ROCR package ----------------
 rocr.pred = ROCR::prediction(probs,labels,label.ordering = c(-1, 1))
      auc.tmp = ROCR::performance(rocr.pred, "auc");
      self$auc = round(mean(as.numeric(auc.tmp@y.values)), digits = 2)
        #End of Calculate AUC using ROCR package ----------------
      return(list(labels = labels, probs = probs, rocr.pred= rocr.pred))
    },
    PlotROCR = function (labels = labels, probs = probs, rocr.pred= rocr.pred) {
#      rocr.pred = ROCR::prediction(probs,labels,label.ordering = c(-1, 1))
      prec_rec = ROCR::performance(rocr.pred, "prec", 'rec')
      prec = ROCR::performance(rocr.pred, measure = "prec")
      rec = ROCR::performance(rocr.pred, measure = "rec")
      tpr_fpr = ROCR::performance(rocr.pred, measure = "tpr", x.measure = "fpr")
      auc.tmp = ROCR::performance(rocr.pred, "auc");
      auc = round(mean(as.numeric(auc.tmp@y.values)), digits = 2)
      par(
        mfrow = c(2,2), oma = c(1,1,1,1), mar = c(5, 4.5, 0, 2) + 0.1
      )
      par(cex.lab = 1.5)
      ROCR::plot(
        prec, avg = "vertical", spread.estimate = "stderror", col = c("#FF0000FF"), ylim =
          c(0,1),xlim = c(0,1)
      )
      ROCR::plot(
        rec, avg = "vertical",spread.estimate = "stderror",col = c("#FF0000FF"),ylim =
          c(0,1),xlim = c(0,1)
      )
      ROCR::plot(
        prec_rec, avg = "vertical", spread.estimate = "stderror", col = c("#FF0000FF"), ylim =
          c(0,1), xlim = c(0,1)
      )
      ROCR::plot(
        tpr_fpr, avg = "vertical",spread.estimate = "stderror",col = c("#FF0000FF"),ylim =
          c(0,1),xlim = c(0,1)
      )
      text(0.7, 0.2, paste("AUC= ", auc, sep = ""),cex = 1.2)
    }
  )
)

x=get(load(file="data_iris2/x.rda"))
y=get(load(file="data_iris2/y.rda"))
cost=1
# -------------------------------------

test_that("iris2_Model_noCost", {
model.obj = Model$new( x = x, y = y)

scores = model.obj$ScoreData(x=x)$scores
model = model.obj$model

testthat::expect_true(all(rownames(model$SV)[1:3]==c("2", "4", "6")))
testthat::expect_equal(as.numeric(scores)[1], 1.032471, tolerance=1e-2)
testthat::expect_equal(as.numeric(scoreData(data=x, model=model.obj))[1], 0.9912151, tolerance=1e-2)
})

test_that("iris2_Model", {
model.obj = Model$new( x = x, y = y, cost=cost)


scores = model.obj$ScoreData(x=x)$scores
model = model.obj$model

testthat::expect_true(all(rownames(model$SV)[1:3]==c("1", "2", "3")))
testthat::expect_equal(as.numeric(scores)[1], -0.534, tolerance=1e-2)
testthat::expect_equal(as.numeric(scoreData(data=x, model=model.obj))[1], 0.9968594, tolerance=1e-2)
})

test_that("iris2_Model_Features", {

feature.ranking = get(load('data_iris2/feature.ranking.rda'))
feature.nb = 4

model.obj = Model$new(x = x, y = y, feature.ranking=feature.ranking, feature.nb=feature.nb, cost=cost)
scores = model.obj$ScoreData(x=x)$scores
model = model.obj$model

testthat::expect_true(all(rownames(model$SV)[1:3]==c("1", "2", "3")))
testthat::expect_equal(as.numeric(scores)[1], -0.548, tolerance=1e-2)
testthat::expect_equal(as.numeric(scoreData(data=x, model=model.obj))[1], 1, tolerance=1e-3)

})

test_that("iris2_createModel", {

data=get(load(file="data_iris2/iris2.rda"))
cl=1

feature.ranking = get(load('data_iris2/feature.ranking.rda'))
feature.nb = 4

model.obj = createModel(data = data, cl = 1, feature.ranking=feature.ranking, feature.nb=feature.nb, cost=cost)
scores = model.obj$ScoreData(x=x)$scores
model = model.obj$model

testthat::expect_true(all(rownames(model$SV)[1:3]==c("1", "2", "3")))
testthat::expect_equal(as.numeric(scores)[1], -0.548, tolerance=1e-2)
testthat::expect_equal(as.numeric(scoreData(data=data, model=model.obj))[1], 1, tolerance=1e-3)

})

x=get(load(file="data_iris2/x.rda"))
y=get(load(file="data_iris2/y.rda"))

feature.nb.vector = list(2,4,6,8,10,12)
step.nb=2
cost=1

# -------------------------------------

test_that("iris2_LedPredClass", {

obj <- LedPredClass$new(x = x, y = y, feature.nb.vector=feature.nb.vector, cost=cost)
scores = obj$model.obj$ScoreData(x=x)$scores

testthat::expect_true(all(obj$feature.ranking[c(1,2), 'FeatureName']==c('Petal.Width', 'Petal.Length')))
testthat::expect_true(obj$best.feature.nb==4)
testthat::expect_true(all(rownames(obj$model$SV)[1:2]==c("1", "2")))
testthat::expect_equal(as.numeric(scores)[1], -0.533, tolerance=1e-2)
testthat::expect_true(all(obj$feature.ranking[c(11,12), 'AvgRank']==c(10.4, 11.4)))

})

test_that("iris2_LedPred", {

data=get(load(file="data_iris2/iris2.rda"))
cl=1

obj <- LedPred(data = data, cl = cl, step.nb=step.nb, cost=cost)
scores = scoreData(data=x, ledpred=obj)

testthat::expect_true(all(obj$feature.ranking[c(1,2), 'FeatureName']==c('Petal.Width', 'Petal.Length')))
testthat::expect_true(all(obj$feature.ranking[c(11,12), 'AvgRank']==c(10.8, 11.4)))
testthat::expect_true(obj$best.feature.nb==4)
testthat::expect_true(all(rownames(obj$model$SV)[1:2]==c("1", "2")))

testthat::expect_equal(as.numeric(scores)[1], 0.998, tolerance=1e-2)

})

#' Create the model with the optimal features
#'
#' \code{createModel} function creates a SVM model from the training data set with the selected features.
#'
#' @param data data.frame containing the training set
#' @param cl integer indicating the column number corresponding to the response vector that classify positive and negative regions (default = 1)
#' @param kernel SVM kernel, a character string: "linear" or "radial". (default = "radial")
#' @param cost The SVM cost parameter for both linear and radial kernels. If NULL (default), the function \code{mcTune} is run.
#' @param gamma The SVM gamma parameter for radial kernel. If radial kernel and NULL (default), the function \code{mcTune} is run.
#' @param valid.times Integer indicating how many times the training set will be split for the cross validation step (default = 10). This number must be smaller than positive and negative sets sizes.
#' @param feature.ranking List of ordered features.
#' @param feature.nb the optimal number of feature to use from the list of ordered features.
#' @param file.prefix A character string that will be used as a prefix followed by "_model.RData" for the resulting model file, if it is NULL (default), no model is saved
#' @return the best SVM model
#' @examples
#'     data(crm.features)
#'     cost <- 1
#'     gamma <- 1
#'     data(feature.ranking)
#'     feature.nb <- 70
#' #svm.model <- createModel(data.granges=crm.features, cost=cost, gamma=gamma,
#' #    feature.ranking=feature.ranking, feature.nb=feature.nb)
#' #feature.weights <- as.data.frame(t(t(svm.model$coefs) %*% svm.model$SV))

createModel = function(data, cl = 1,kernel = "radial",cost = 1,gamma =
             1, valid.times = 10, feature.ranking = NULL,feature.nb = NULL,file.prefix = NULL) {

data = data[order(data[,cl], decreasing=TRUE), ] # sort positive labels first
x=data[,-cl]
y=data[,cl]

#selected.features = as.character(feature.ranking$FeatureName[1:feature.nb])
#x = x[,selected.features]
model.obj <- Model$new(x = x, y = y, file.prefix=file.prefix, feature.ranking = feature.ranking, feature.nb = feature.nb, cost=cost, gamma=gamma)
#save(model.obj, file = paste(file.prefix,"_model.rda",sep = "")) # can save model for later use

return(model.obj)
}

#' Tuning the SVM parameters
#'
#' The \code{mcTune} function is a modified version of the function \code{tune}  from package e1071  [6]. It tests the different combinations of C and gamma parameters given as vectors in a list and will return the prediction error computed during the cross-validation step.
#'
#' @param data data.frame containing the training set
#' @param cl integer indicating the column number corresponding to the response vector that classify positive and negative regions (default = 1)
#' @param ranges list object containing one (linear kernel) or two (radial kernel) vectors of integers corresponding to SVM cost and SVM gamma parameters to test.
#' @param kernel SVM kernel, a character string: "linear" or "radial". (default = "radial")
#' @param valid.times Integer indicating how many times the training set will be split for the cross validation step (default = 10). This number must be smaller than positive and negative sets sizes.
#' @param file.prefix A character string that will be used as a prefix followed by "_c_g_eval.png" for result plot files, if it is NULL (default), no plot is returned
#' @param numcores Number of cores to use for parallel computing (default: the number of available cores in the machine - 1)
#' @return A list of class \code{tune}
#' \item{best.parameters}{A list of the parameters giving the lowest misclassification error}
#' \item{best.performance}{The lowest misclassification error}
#' \item{method}{The method used}
#' \item{nparcomb}{the number of tested parameter combinations}
#' \item{train.ind}{The indexes used to produce subsets during the cross validation step}
#' \item{sampling}{The cross-validation fold number}
#' \item{performances}{A matrix summarizing the cross-validation step with the error for each tested parameter at each round and the dispersion of these errors (regarding to the average error)}
#' \item{best.model}{The model produced by the best parameters}
#' @examples
#' data(crm.features)
#' cost.vector <- c(1,3,10,30)
#' gamma.vector <- c(1,3,10,30)
#' #c.g.obj <- mcTune(data.granges= crm.features, ranges = list(cost=cost.vector,
#' #    gamma=gamma.vector), kernel='linear', file.prefix = "test")
#' #names(c.g.obj)
#' # cost <- c.g.obj$best.parameters$cost
#' # gamma <- c.g.obj$best.parameters$gamma

mcTune <- function(data, cl = 1,
                   ranges = list(gamma=c(1,10), cost=c(1,10)), kernel = "linear",
                   valid.times = 10,
                   file.prefix = NULL, numcores=ifelse(.Platform$OS.type == "windows", 1,  parallel::detectCores() - 1)) {

data = data[order(data[,cl], decreasing=TRUE), ] # sort positive labels first
x=data[,-cl]
y=data[,cl]

tune.parameters.obj <-ParameterTuner$new(x = x, y = y, ranges=ranges, kernel = kernel,
                   valid.times = valid.times,
                   file.prefix = file.prefix, numcores = numcores)

return(tune.parameters.obj)
}

#' This is data to be included in my package
#'
#' @name crm.features
#' @docType data
NULL

#' This is data to be included in my package
#'
#' @name feature.ranking
#' @docType data
NULL

Data <- R6::R6Class(
  "Data",
  public = list(
    x = NULL,
    y = NULL,
    kernel = "linear",
    cost = NULL,
    gamma = NULL,
    valid.times = 5,
    test.folds = NULL,
    scale.factors = NULL,
#    scale.center = NULL,
#    scale.scale = NULL,
    numcores = ifelse(.Platform$OS.type == "windows", 1,  parallel::detectCores() - 1),
    file.prefix = NULL,
    initialize = function(x, y, kernel = self$kernel, cost = self$cost, gamma =
                            self$gamma, valid.times = self$valid.times, numcores = self$numcores, file.prefix = self$file.prefix) {
      self$x = x #assign to self
      self$x[is.na(self$x)] <- 0 #replace NAs with zeros
      self$scale.factors = apply(self$x, 2, function(x) sqrt(sum(x^2))) # store scale factors
#      self$scale.center = colMeans(x) #store scale center
#      self$scale.scale = matrixStats::colSds(as.matrix(x)) #store scale scale
#      self$x = scale(x, center = self$scale.center, scale = self$scale.scale)
      self$x = t(t(self$x)/self$scale.factors) #scale x
      self$y = as.factor(y) #store y
      if (!missing(kernel))
        self$kernel = kernel
      if (!missing(cost))
        self$cost = cost
      if (!missing(gamma))
        self$gamma = gamma
      if (!missing(valid.times))
        self$valid.times <- valid.times
      if (self$valid.times > 1)
        self$test.folds = self$MakeCrossValidSets(self$valid.times)
    },
    MakeCrossValidSets = function(valid.times) {
      nrows = nrow(self$y)
      perm.ind.pos = which(self$y == "1")
      nrows.pos = length(perm.ind.pos)
#      browser()
      perm.ind.neg = which(self$y == "-1")
      nrows.neg = length(perm.ind.neg)
      if (valid.times > nrows.pos)
        stop(sQuote("cross"), " must not exceed positive or negative set sizes!")
      if (valid.times == 1)
        stop(sQuote("cross"), " must be greater than 1!")
      test.folds.pos = tapply(1:nrows.pos, cut(1:nrows.pos, breaks =  valid.times), function(x)
        perm.ind.pos[x])
      test.folds.neg = tapply(1:nrows.neg, cut(1:nrows.neg, breaks =  valid.times), function(x)
        perm.ind.neg[x])
      test.folds = lapply(1:length(test.folds.pos), function (x)
        c(test.folds.pos[[x]], test.folds.neg[[x]]))
      return(test.folds)
    }
  ),
  private = list(type = 'C-classification',
                 scale = FALSE)
)

#' Evaluate model performances
#'
#' \code{evaluateModelPerformance} function computes the precision and recall measures to evaluate the model through cross validation steps using \code{ROCR} package.
#'
#' @param data data.frame containing the training set
#' @param cl integer indicating the column number corresponding to the response vector that classify positive and negative regions (default = 1)
#' @param kernel SVM kernel, a character string: "linear" or "radial". (default = "radial")
#' @param cost The SVM cost parameter for both linear and radial kernels. If NULL (default), the function \code{mcTune} is run.
#' @param gamma The SVM gamma parameter for radial kernel. If radial kernel and NULL (default), the function \code{mcTune} is run.
#' @param valid.times Integer indicating how many times the training set will be split for the cross validation step (default = 10). This number must be smaller than positive and negative sets sizes.
#' @param feature.ranking List of ordered features.
#' @param feature.nb the optimal number of feature to use from the list of ordered features.
#' @param file.prefix A character string that will be used as a prefix followed by "_ROCR_perf.png" for the result plot file, if it is NULL (default), no plot is returned
#' @param numcores Number of cores to use for parallel computing (default: the number of available cores in the machine - 1)
#' @return A list with two objects.
#' \item{probs}{The predictions computed by the model for each subset during the cross-validation}
#' \item{labels}{The actual class for each subset}
#' @examples
#'data(crm.features)
#' data(feature.ranking)
#'#probs.labels.list <- evaluateModelPerformance(data.granges=crm.features,
#'#    feature.ranking=feature.ranking, feature.nb=50,
#'#    file.prefix = "test")
#'#names(probs.labels.list[[1]])

evaluateModelPerformance = function(data, cl = 1, valid.times = 10, feature.ranking = NULL, feature.nb =NULL, numcores=ifelse(.Platform$OS.type == "windows", 1,  parallel::detectCores() - 1), file.prefix = NULL, kernel = "linear", cost = NULL, gamma = NULL) {

data = data[order(data[,cl], decreasing=TRUE), ] # sort positive labels first
x=data[,-cl]
y=data[,cl]

cv.probs.labels = ModelPerformance$new(x, y, valid.times = valid.times, feature.ranking = feature.ranking, feature.nb =feature.nb, numcores =
                                      numcores, file.prefix = file.prefix, kernel = kernel, cost = cost, gamma = gamma)$cv.probs.labels

return(cv.probs.labels)

}

x=get(load(file="data_iris2/x.rda"))
y=get(load(file="data_iris2/y.rda"))

data=get(load(file="data_iris2/iris2.rda"))
cl=1
# -------------------------------------

cost=1

test_that("fast_ModelPerformance", {

feature.ranking = get(load('data_iris2/feature.ranking.rda'))
best.feature.nb=2
selected.features = as.character(feature.ranking$FeatureName[1:best.feature.nb])
x = x[,selected.features]
modelperf.obj <- ModelPerformance$new(x = x, y = y)

testthat::expect_equal(modelperf.obj$auc, 1, tolerance=1e-2)
testthat::expect_equal(as.numeric(modelperf.obj$cv.probs.labels$probs[1,1]), 0.9788528, tolerance=1e-5)

cv.probs.labels <- evaluateModelPerformance(data = data, cl = 1, cost=cost)
testthat::expect_equal(as.numeric(cv.probs.labels$probs[1,1]), 0.9989729, tolerance=1e-3)
}
)

test_that("fast_ModelPerformance", {

# --------------------------
feature.ranking = get(load('data_iris2/feature.ranking.rda'))
best.feature.nb=2
selected.features = as.character(feature.ranking$FeatureName[1:best.feature.nb])
x = x[,selected.features]
modelperf.obj <- ModelPerformance$new(x = x, y = y, cost=cost)

testthat::expect_equal(modelperf.obj$auc, 1, tolerance=1e-2)
testthat::expect_equal(as.numeric(modelperf.obj$cv.probs.labels$probs[1,1]), 0.9994173, tolerance=1e-5)

cv.probs.labels <- evaluateModelPerformance(data = data, cl = 1, cost=cost)
testthat::expect_equal(as.numeric(cv.probs.labels$probs[1,1]), 0.9989729, tolerance=1e-3)
}
)

#' Predicting new regulatory regions
#'
#' \code{scoreData} function predict new regulatory regions using SVM model from a test data set
#'
#' @param data data.frame containing the test set. This test set must have the same descriptive features as the one that were used to build the model.
#' @param model Returned object of the createModel function
#' @param ledpred Returned object from the LedPred function
#' @param score.file A character string that will be used as the file name for the output file, if it is NULL (default), no file is writen. The output file takes the form of two columns with object names and scores.
#' @return A 2-columns dataframe. First column containg the SVM model prediction probabilities and the second containing the corresponding regions
#' @examples
#' data(crm.features)
#' data(svm.model)
#' #pred.test <- scoreData(data.granges=crm.features, model=svm.model,
#' # score.file="test_prediction.tab")

scoreData <- function(data, ledpred=NULL, model=NULL, score.file = NULL) {

scores=NULL

if(!is.null(ledpred))  {
	scores = ledpred$model.obj$ScoreData(x=data)$probs

} else if (!is.null(model))  {
	scores = model$ScoreData(x=data)$probs
}

scores=sort(scores, decreasing=TRUE)

if(!is.null(score.file)) {
	write.table(scores, file=score.file, quote=FALSE, col.names=FALSE)
}
return(scores)

}

x=get(load(file="data_iris2/x.rda"))
y=get(load(file="data_iris2/y.rda"))

# -------------------------------------
valid.times=5

test_that("iris2_Model", {

data.obj = Data$new(x=x, y=y)

testthat::expect_equal(as.numeric(data.obj$x[1,1]), 0.0706, tolerance=1e-3)
})

kernel='linear'
type='C-classification'
ranges = list(gamma = 2^(-1:1), cost = 2^(2:4))
valid.times = 10
numcores <- ifelse(.Platform$OS.type == "windows", 1,  parallel::detectCores() - 1)
#numcores = 1

test_that("iris2_ParameterTuner", {

x = iris[,-which(names(iris) == "Species")]
y = ifelse(iris$Species=='setosa',1,-1)

e1071.tune <- e1071::tune(e1071::svm, train.y=as.factor(y), train.x=x, kernel=kernel, type=type, ranges = ranges, tunecontrol = e1071::tune.control(sampling = "cross", cross=valid.times))

tune.parameters.obj <-ParameterTuner$new(x = x, y = y, kernel=kernel, ranges=ranges, valid.times = valid.times, numcores=numcores)

testthat::expect_true(tune.parameters.obj$cost==e1071.tune$best.parameters$cost)
testthat::expect_true(tune.parameters.obj$gamma==e1071.tune$best.parameters$gamma)

})

test_that("mtcars_ParameterTuner", {

data(mtcars)
x = mtcars[,-which(names(mtcars) == "vs")]
y = ifelse(mtcars$vs==1,1,-1)

e1071.tune <- e1071::tune(e1071::svm, train.y=as.factor(y), train.x=x, kernel=kernel, type=type, ranges = ranges, tunecontrol = e1071::tune.control(sampling = "cross", cross=valid.times))

testthat::expect_true(e1071.tune$best.parameters$cost==4)
testthat::expect_true(e1071.tune$best.parameters$gamma==0.5)

tune.parameters.obj <-ParameterTuner$new(x = x, y = y, kernel=kernel, ranges=ranges, valid.times = valid.times, numcores=numcores)

testthat::expect_true(tune.parameters.obj$cost==16)
testthat::expect_true(tune.parameters.obj$gamma==0.5)

})

x=get(load(file="data_iris2/x.rda"))
y=get(load(file="data_iris2/y.rda"))

# -------------------------------------
valid.times=5
cost=1

test_that("iris2_FeatureRanking_kfold.nb=1", {

kfold.nb=1

# -------------------------------------
feature.ranking.obj <-FeatureRanking$new(x = x, y = y, valid.times = valid.times, cost=cost)
testthat::expect_true(all(feature.ranking.obj$feature.ranking[c(1,2), 'FeatureName']==c('Petal.Width', 'Petal.Length')))
testthat::expect_true(all(feature.ranking.obj$feature.ranking[c(11,12), 'AvgRnk']==c(8.8, 1.6)))

})

test_that("iris2_rankFeatures_kfold.nb=1", {

kfold.nb=1

data=get(load(file="data_iris2/iris2.rda"))
cl=1

# -------------------------------------
feature.ranking <-rankFeatures(data = data, cl =cl , valid.times = valid.times, cost=cost)
#print(feature.ranking)
testthat::expect_true(all(feature.ranking[c(1,2), 'FeatureName']==c('Petal.Width', 'Petal.Length')))
testthat::expect_true(all(feature.ranking[c(11,12), 'AvgRnk']==c(9.8, 10)))

})

x=get(load(file="data_iris2/x.rda"))
y=get(load(file="data_iris2/y.rda"))

# -------------------------------------
valid.times=5
cost=1

# -------------------------------------
feature.ranking = get(load('data_iris2/feature.ranking.rda'))
feature.nb.vector = list(2,4,6,8,10,12)

test_that("iris2_FeatureNbTuner_costIsNull", {
feature.nb.tuner = FeatureNbTuner$new( x = x, y = y, valid.times = valid.times, feature.ranking = feature.ranking, feature.nb.vector = feature.nb.vector)

testthat::expect_true(feature.nb.tuner$best.feature.nb==2)
testthat::expect_equal(feature.nb.tuner$feature.performances['cv.kappa.mean',][[1]], 1,tolerance=1e-6)
})

test_that("iris2_FeatureNbTuner", {
feature.nb.tuner = FeatureNbTuner$new( x = x, y = y, valid.times = valid.times, feature.ranking = feature.ranking, feature.nb.vector = feature.nb.vector, cost=cost)

testthat::expect_true(feature.nb.tuner$best.feature.nb==4)
testthat::expect_equal(feature.nb.tuner$feature.performances['cv.kappa.mean',][[1]], 0.9009967,tolerance=1e-6)
})

test_that("iris2_tuneFeatureNb", {

data=get(load(file="data_iris2/iris2.rda"))
cl=1
step.nb=2

feature.nb.tuner = tuneFeatureNb(data = data, cl = cl, step.nb=step.nb, valid.times = valid.times, feature.ranking = feature.ranking, cost=cost)

testthat::expect_true(feature.nb.tuner$best.feature.nb==2)
testthat::expect_equal(feature.nb.tuner$feature.performances['cv.kappa.mean',][[1]], 1,tolerance=1e-2)
})

\documentclass[a4paper]{article}

\usepackage{datetime}
\usepackage[utf8]{inputenc}
\usepackage{amsmath,amssymb}
\usepackage{cite} % Make references as [1-4], not [1,2,3,4]
\usepackage{url}  % Formatting web addresses
\usepackage{graphicx}
\usepackage{indentfirst}
\usepackage[draft]{todonotes}
\usepackage{listings}
\usepackage{float}
\usepackage{amsmath}
\usepackage{mathtools}

\title{LedPred: Learning from DNA to Predict enhancers}
\author{Elodie Darbo, Denis Seyres, Aitor Gonzalez}
\date{\today}

\begin{document}

\SweaveOpts{concordance=FALSE}
% \VignetteIndexEntry{LedPred Example}

\maketitle

\tableofcontents

\section{Introduction}

Biological processes, such as cell/tissue differentiation, involve several regulatory networks of transcription factors and signalling inputs. The complexity of these networks and what these pathways control in terms of downstream gene networks remains largely unknown. 

Using the information contained in few known regulatory elements driving the expression in a specific biological process, this package predicts new cis-regulatory modules (CRMs) using support vector machine (SVM) learning of transcription factor binding sites (TFBS) motifs, next-generation sequencing (NGS) data signal and any set of pre-calculated values. This vignette uses Drosophila data, but the package can be used with any species and has been tested with human data.

\section{Description}

\subsection{Data}

The data were generated by collecting experimentally validated CRMs and random genomic coordinates. In this example, we focused in CRMs involved in heart differentiation in Drosophila melanogater and ortholog regions in other Drosophila species. 
The genomic sequences were scanned and scored with 259 Drosophila Position-Specific Scoring Matrices (PSSMs) using \textit{matrix-scan} \cite{Turatsinze2008}. From these results, a feature matrix (from our \textit{mapFeaturesToCRMs} function) containing the training set has been built. It contains a line per genomic region and a column per feature plus a binary response vector column (1 and -1 for positive and negative sequences respectively). The files used to produce this example are stored in the \textit{extdata} folder of this package.

<<crm.features,echo=TRUE,eval=TRUE>>=
library(LedPred)
data(crm.features)
@

\subsection{Learning from CRM-contained information to predict new regulatory features}

\subsubsection{Building the training set}

\begin{description}
\item[Positive Regions] \hfill \\
The positive regions define the template from which new regions will be predicted. These regions are known to be involved in the process of interest and we assume that they contain the information specific to this process. 
\item[Negative Regions] \hfill \\
The negative regions allow the model to learn which information are relevant to describe the positive regions and which are found randomly. These regions can be provided by the user or computed by shuffling the positive regions coordinates over a set of background sequences.
\item[Descriptive features: Position-Specific Scoring Matrices] \hfill \\
We retrieve the DNA sequences corresponding to the genomic coordinates and scan them with transcription factor matrices using \textit{matrix-scan} \cite{Turatsinze2008}. This tools computes a p-value with each matrix for each position of the sequence depending on the likelihood of the site to belong to the matrix over the likelihood to belong to the background. Both likelihoods are computed using a markov model. The output is a list of significant p-values per sequence and region corresponding to binding sites of the transcription factor (TF) in the sequence. To compute a score per region and TF, we calculate the sum of the negative logarithm to base 10 of the p-values of binding sites in a sequence, i.e. $\sum_i -log_{10}(\text{p-val}_i)$ where $i$ is the index of the significant p-values corresponding to the binding sites. 
\item[Descriptive features: NGS data] \hfill \\
These data can be given in two different formats: (i) Peak files containing the genomic coordinates in Bed format of regions significantly enriched in signal. These regions are usually defined by using a peak-calling algorithm. In this case a binary value is attributed to the region: 1 if there is an overlap between the region and one or several peaks, 0 otherwise. The minimal overlap fraction of the region is controlled by the \textit{bed.overlap} argument. The default value is 1bp of the region. (ii) Signal files (wig or bigwig formats, see UCSC help for details) containing the genome-wide affinity signal. In this case, we compute the average number of reads in the region.
\end{description}

\subsubsection{Optimization of support vector machine model}

Machine learning approaches are used to build models that are able to discriminate between positive and negative sets combining and weighting information given by some predictors, here we use the presence of instance of PSSMs in the regions. This model is then used to predict new positive features. The negative and positive regions are labeled by a binary response vector. The resulting matrix is named the training set. The goal is to define a function as close as possible to the response vector. The method assigns to each descriptive feature a weight corresponding to the impact of the feature in the discrimination between positive and negative regions. Here we propose a method using Support Vector Machine (SVM) and tested with the linear or radial kernels. This package is based on the libsvm and can be used in principle with other kernels of this library \cite{libsvm}.

\begin{itemize}
\item The SVM with linear kernel assumes that there exists a linear hyper plane that separates positive and negative data. As it exists an infinity of such planes, the SVM will maximize the margin between the positive/negative sets and the plane. The $\beta$ parameters variance is constrained by the cost parameter C ($1/\lambda$). This parameter allows to avoid overfitting by relaxing this constrain. 

\item The radial kernel function is a similarity function which transforms the descriptive feature space in a space of higher dimension. It assumes that there is no linear hyperplane able to separate the positive and negative regions. Two variables are very important: the cost parameter C and the $\gamma$ parameter ($ \gamma / \sigma^{2} $) which allows to smoothen the similarity function in order to be more or less stringent. The similarity function returns a probability between 0 and 1.
\end{itemize}

The aim of this package is to compute a predictive model general enough to avoid the overfitting the training set. We propose a sequential pipeline to achieve this purpose:

\subsubsection{Definition of the optimal SVM parameters ($\gamma$ and C)}

We test the different combinations of C and $\gamma$ parameters given by the user and return the prediction error computed using cross-validation. At this step, each set (positive and negative) is partitioned in subsets. One subset of each group is used as a training set to predict in the remaining subsets the positive and negative regions, the error of prediction is then calculated. This error represents overfitting, which means that the model is too specific to the training set and fails to generalise and predict new regions. 

\subsubsection{Sorting and selecting features according to their importance in the traing set description}

The ranked list of features based on decreasing "importance" is computed by recursive feature elimination (RFE) \cite{Duan2005,Colby2011}. During this step, SVM is train on subsets of the \textit{feature.matrix} and ranked according to the weight given by the resulting classifier. A mean rank ("importance") is attributed to each feature. 

To select the optimal number of features, we compute the Cohen's kappa coefficient \cite{Byrt1993} of models built from increasing number of features from the sorted list of features, the step of the incrementation is defined by the \textit{step.nb} parameter.\\
The kappa coefficient is defined as:

\begin{equation}
\kappa=\frac{Pr(a)-Pr(e)}{1-Pr(e)}
\end{equation}

where $Pr(a)$ is the observed accuracy, that is the proportion of well predicted regions (True Positive TP, True Negative TN) among the total number of regions (N).

\begin{equation}
Pr(a) =  \frac{TP + TN}{N} 
\end{equation}

$Pr(e)$ is the expected accuracy that represents the accuracy that any random classifier would be expected to achieve. $Pr(e)$ is defined as:

\begin{equation}
Pr(e) = \frac{(TP+FN)*(TP+FP)}{N} + \frac{(FP+TN)*(FN+TN)}{N}
\end{equation}

where, $TP$: True Positive; $TN$: True Negative; $FP$: False Positive; $FN$: False Negative; $N$ the total number of objects.

Given the optimal parameters and features, we can create now the model.

\subsubsection{Plotting the performances of the model}
We can evaluate the selected model by plotting the precision/recall, the precision/cut off, the recall/cut off and the ROC curves. This is performed using cross-validation results. We used the R package ROCR \cite{Sing2005}.

\begin{equation}
precision = \frac{TP}{TP + FP}\\
\end{equation}

\begin{equation}
recall = \text{true positive rate} = \frac{TP}{TP + FN}\\
\end{equation}

\begin{equation}
\text{false positive rate} = \frac{FP}{TN + FP}\\
\end{equation}

The $precision$ indicate the proportion of true positive among all the regions predicted as positive. The $recall$ indicates the proportion of true positive detected among all the true positive. Thanks to these curves we can choose the most appropriate cut off on the probability according to the question. Here we want to select regions in order to test them experimentally so we want high precision to avoid false positive. The ROC curve represents the false positive rate against the $true positive rate$, a high area under the resulting curve means that the model can return high number of positive regions with a low false positive rate.

\subsection{Function description}

\subsubsection{From bed CRM genomic coordinates to training set matrix}

The \textit{mapFeaturesToCRMs} function takes BED files containing the coordinates of the positive regions and for the negative set a bed file or a set of background sequences for sampling randomly. Regarding the features, a transfac file with PSSMs and another file with background frequences, BED or WIG files for NGS data and a BED files with arbitrary values in the first column. This function requires a very diverse palette of tools for this computation, namely \textit{RSAT matrix-scan} \cite{Turatsinze2008}, \textit{BedTools} \cite{Quinlan2010} and IntervalStats  \cite{Chikina2012}. To simplify its use, the \textit{mapFeaturesToCRMs} function will connect to a REST server, send the data, and get the results of the calculations. The result is a list with the matrix as a \textit{data.frame} object, and the standard and error logs of the computation.

<<mapFeaturesToCRMs,echo=TRUE,eval=TRUE>>=
dirPath <- system.file("extdata", package="LedPred")
file.list <-   list.files(dirPath, full.names=TRUE)
background.freq <- file.list[grep("freq", file.list)]
positive.regions <-  file.list[grep("positive", file.list)]
negative.regions <-  file.list[grep("negative", file.list)]
TF.matrices <-  file.list[grep("tf", file.list)]
ngs.path <- system.file("extdata/ngs", package="LedPred")
ngs.files=list.files(ngs.path, full.names=TRUE)
#crm.feature.list <- mapFeaturesToCRMs(URL = 'http://ifbprod.aitorgonzalezlab.org/map_features_to_crms.php', positive.bed=positive.regions, negative.bed=negative.regions, background.freqs=background.freq, pssm=TF.matrices, genome="dm3", ngs=ngs.files,  crm.feature.file = "vignette_crm.features.tab",  stderr.log.file = "vignette_stderr.log", stdout.log.file = "vignette_stdout.log")
#names(crm.feature.list)
#class(crm.feature.list$crm.features)
@

\subsubsection{Scaling of the CRM feature matrix}

The PSSM calculation returns feature vectors with values organized similar to negative exponential distributions and average of around 0.08. The intersection of BED files with the sequences return mostly zero values and and some ones. To bring both values to the same range all values are divided internally with the Euclidean length of the feature vector.


\subsubsection{SVM parameter optimization}

The \textit{mcTune} function is a modified version of the function \textit{tune} from package \textit{e1071} that uses parallel computation \cite{Meyer2014}. It tests the different combinations of cost C and gamma parameters given as vectors in a list and will return the prediction error computed during the cross-validation step. The results is a list containing the best parameters (Fig. \ref{fig1})..

<<mcTune, echo=TRUE,eval=TRUE>>=
#crm.features=crm.feature.list$crm.features
#cost.vector <- c(1,3,10)
#gamma.vector <- c(1,3,10)
#c.g.obj <- mcTune(data = crm.features, ranges = list(cost=cost.vector, gamma=gamma.vector), kernel='linear', file.prefix = "vignette")
#names(c.g.obj)
#cost <- c.g.obj$e1071.tune.obj$best.parameters$cost
#gamma <- c.g.obj$e1071.tune.obj$best.parameters$gamma
@

\begin{figure}[H]
\centering
\includegraphics[scale=0.5]{figs/vignette_c_g_eval.png}
\caption{\label{fig1} Error prediction by SVM linear kernel method. We use the same plot for linear and radial kernel mcTune optimization but gamma does not give any information for the linear kernel.}
\end{figure}

\subsubsection{Features ranking}
The \textit{rankFeatures} function performs a Recursive Feature Elimination (RFE) and return a \textit{data.frame} object containing the ranked features list, their ID (number of the column in the feature matrix) and the average rank.

<<echo=TRUE,eval=TRUE>>=
#feature.ranking <- rankFeatures(data=crm.features, cost=cost, gamma=gamma, kernel='linear', file.prefix = "vignette")
#head(feature.ranking)
@

\subsubsection{Selecting features}
The \textit{tuneFeatureNb} function computes the kappa measure on the feature matrix in which the features are ranked according to their decreasing importance. It starts with one feature and increases the number of features included in the matrix by an step (nb.step argument) until all features are included. This step depends \textit{feature.ranking} object from the step before. The returned object is a list contaning a data frame summarizing the kappa coefficient for the different number of features included in the model. We keep the number corresponding to the highest kappa for the following steps (Fig. \ref{fig2}).

<<echo=TRUE,eval=TRUE>>=
#feature.nb.tuner.obj <- tuneFeatureNb(data=crm.features, feature.ranking=feature.ranking, kernel='linear', cost=cost, gamma=gamma, file.prefix = "vignette")
#names(feature.nb.tuner.obj)
#feature.nb.tuner.obj$best.feature.nb
@

\begin{figure}[H]
\centering
\includegraphics[scale=0.5]{figs/vignette_kappa_measures.png}
\caption{\label{fig2} Kappa coefficient showing the performance of the model as a function of the number of features.}
\end{figure}

\subsubsection{Creating the best model}
The \textit{createModel} function takes the tuned SVM parameters, the ranked features and the optimal number of features and returns a SVM model.

<<echo=TRUE,eval=TRUE>>=
#feature.nb <- 60
#model.obj <- createModel(data=crm.features, cost=cost, gamma=gamma, feature.ranking=feature.ranking, feature.nb=feature.nb, file.prefix="vignette")
#names(model.obj)
#model.obj$model
@

An interesting information is the sign of the feature weights, which tells whether the feature is over- or under-represented in the positive or negative sets. It can be shown for each feature with this command:

<<echo=TRUE,eval=TRUE>>=
#feature.weights <- as.data.frame(t(t(model.obj$model$coefs) %*% model.obj$model$SV))
#head(feature.weights)
@

\subsubsection{Plotting model perfomance}
The \textit{evaluateModelPerformance} function returns a list of prediction probabilities computed during the rounds of cross-validation and plots the performance results (Fig \ref{fig3}).

<<echo=TRUE,eval=TRUE>>=
#probs.labels.list <- evaluateModelPerformance(data=crm.features, feature.ranking=feature.ranking, feature.nb=feature.nb, cost=cost, gamma=gamma, file.prefix = "vignette")
@

\begin{figure}[H]
\centering
\includegraphics[scale=0.5]{figs/vignette_ROC_perf.png}
\caption{\label{fig3} Model performance. Four plots and the AUC are given to evaluate the performance of the model: Precision and recall as a function of the score, precision versus recall and the ROCR curve with the area under the curve (AUC).}
\end{figure}

\subsubsection{Using the model to score unknown sequences}

In the last step, we want the model to score unknown sequences. With this aim, we need first to create a numerical matrix for the unknown sequences with the best features. This matrix can be created by our \textit{mapFeaturesToCRMs} function using the \textit{feature.nb} and the \textit{feature.rank} arguments to select the relevant features, by setting \textit{negative.bed}  argument at \textit{NULL} and  \textit{shuffling} argument at 0 to produce a feature matrix that does not contain negative sequences.

<<mapFeaturesToCRMs2, echo=TRUE,eval=TRUE>>=
dirPath <- system.file("extdata", package="LedPred")
file.list <-   list.files(dirPath, full.names=TRUE)
background.freqs <- file.list[grep("freq", file.list)]
positive.bed <-  file.list[grep("prediction_small", file.list)]
TF.matrices <-  file.list[grep("259_matrices_lightNames", file.list)]
ngs.path <- system.file("extdata/ngs", package="LedPred")
ngs.files=list.files(ngs.path, full.names=TRUE)
#prediction.crm.features.list <- mapFeaturesToCRMs(URL = 'http://ifbprod.aitorgonzalezlab.org/map_features_to_crms.php', positive.bed=positive.bed, 
#  pssm=TF.matrices, background.freqs=background.freqs, 
#  genome='dm3', ngs=ngs.files, feature.ranking=feature.ranking, feature.nb=feature.nb, 
#    crm.feature.file = "vignette_pred.crm.features.tab", 
#    stderr.log.file = "vignette_pred.stderr.log", stdout.log.file = "vignette_pred.stdout.log")
#names(prediction.crm.features.list)
#prediction.crm.features <- prediction.crm.features.list$crm.features
@

This creates a matrix for the unknown sequences that can be used by the \textit{scoreData} function with the \textit{model} argument to score the sequences of the matrix.

<<scoreData,echo=TRUE,eval=TRUE>>=
#pred.test <- scoreData(data=prediction.crm.features, model=model.obj, score.file="vignette_prediction.tab")
#pred.test
@

\subsubsection{From the matrix to the model in one function}

The \textit{LedPred} function takes the numerical matrix created by \textit{mapFeaturesToCRMs} and runs sequentially all functions needed to create the model. It returns a list containing all the objects produced at each each step.

<<ledpred,echo=TRUE,eval=TRUE>>=
crm.features=data(crm.features)
cost.vector <- c(1,3,10)
gamma.vector <- c(1,3,10)
#ledpred.obj=LedPred(data=crm.features, cl=1, ranges = list(cost=cost.vector, gamma=gamma.vector), kernel="linear", file.prefix="vignette2")
#names(ledpred.obj)
@

We annotate test data again

<<mapFeaturesToCRMs3,echo=TRUE,eval=TRUE>>=
dirPath <- system.file("extdata", package="LedPred")
file.list <-   list.files(dirPath, full.names=TRUE)
background.freqs <- file.list[grep("freq", file.list)]
positive.bed <-  file.list[grep("prediction_small", file.list)]
TF.matrices <-  file.list[grep("259_matrices_lightNames", file.list)]
ngs.path <- system.file("extdata/ngs", package="LedPred")
ngs.files=list.files(ngs.path, full.names=TRUE)
#prediction.crm.features.obj2 <- mapFeaturesToCRMs(URL = 'http://ifbprod.aitorgonzalezlab.org/map_features_to_crms.php', positive.bed=positive.bed, 
#  pssm=TF.matrices, background.freqs=background.freqs, 
#  genome='dm3', ngs=ngs.files, feature.ranking=ledpred.obj$feature.ranking, feature.nb=ledpred.obj$feature.nb, 
#    crm.feature.file = "vignette2_pred.crm.features.tab", 
#    stderr.log.file = "vignette2_pred.stderr.log", stdout.log.file = "vignette2_pred.stdout.log")
#names(prediction.crm.features.obj2)
#prediction.crm.features2 <- prediction.crm.features.obj2$crm.features
@

Now we can score test data

<<scoreData2,echo=TRUE,eval=FALSE>>=
#pred.test2 <- scoreData(data=prediction.crm.features2, model=ledpred.list$model.obj, score.file="vignette2_prediction.tab")
#pred.test2
@

\section{Session Information}
Here is the output of \textit{sessionInfo} on the system on which
this document was compiled:

<<echo=TRUE,eval=TRUE>>=
sessionInfo()
@

\begin{thebibliography}{10}
\providecommand{\url}[1]{[#1]}
\providecommand{\urlprefix}{}

\bibitem{Turatsinze2008}
Turatsinze JV, Thomas-Chollier M, Defrance M, van Helden J.: \textbf{{Using RSAT to scan genome sequences for transcription factor binding sites and cis-regulatory modules.}} \emph{Nature Protocole} 2008, \textbf{3}: (10) 1578-88.

\bibitem{Duan2005}
Duan K.-B., Rajapakse J. C., Wang H., and Azuaje F.: \textbf{Multiple SVM-RFE for gene selection in cancer classification with expression data}. \emph{IEEE transactions on nanobioscience} 2005, \textbf{4}: (3) 228-234.

\bibitem{Colby2011}
Colby J: \textbf{{R implementation of the (multiple) Support Vector Machine Recursive Feature Elimination - mSVM-RFE.}} \url{http://github.com/johncolby/SVM-RFE} 2011.

\bibitem{Byrt1993}
Byrt T., Bishop J and Carlin J.B.: \textbf{Bias, prevalence and kappa.} \emph{Journal of Clinical Epidemiology}, 1993 \textbf{46}: 423–429.

\bibitem{Sing2005}
Sing T., Sander O, Beerenwinkel N. and Lengauer T.: \textbf{ROCR: visualizing classifier performance in R.} \emph{Bioinformatics}, 2005 \textbf{21}: (20) 7881.

\bibitem{Meyer2014}
Meyer D., Dimitriadou E., Hornik K., Weingessel A., Leisch F., Chang C.C., Lin C.C.: \textbf{e1071: Misc Functions of the Department of Statistics (e1071)} \url{http://cran.r-project.org/web/packages/e1071/}, 2014

\bibitem{Quinlan2010}
Quilan A.R. and Hall I.M.: \textbf{BEDTools: a flexible suite of utilities for comparing genomic features} \emph{Bioinformatics}, 2010 \textbf{26}: (6) 841-2

\bibitem{Chikina2012}
Chikina M.D. and Troyanskaya O.G.: \textbf{An effective statistical evaluation of ChIPseq dataset similarity} \emph{Bioinformatics}, 2012 \textbf{28}: (5) 607-13

\bibitem{libsvm}
Chang, Chih-Chung and Lin, Chih-Jen : \textbf{{LIBSVM}: A library for support vector machines} \emph{ACM Transactions on Intelligent Systems and Technology} 2011 \textbf{2}: (5) 27:1-27:27

\end{thebibliography}
\end{document}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rankFeatures.R
\name{rankFeatures}
\alias{rankFeatures}
\title{Ranking the features according to their importance}
\usage{
rankFeatures(data, cl = 1, halve.above = 100, valid.times = 10,
  kernel = "linear", cost = 1, gamma = 1,
  numcores = ifelse(.Platform$OS.type == "windows", 1, parallel::detectCores()
  - 1), file.prefix = NULL)
}
\arguments{
\item{data}{data.frame containing the training set}

\item{cl}{integer indicating the column number corresponding to the response vector that classify positive and negative regions (default = 1)}

\item{halve.above}{During RFE, all the features are ranked at the first round and the half lowest ranked features (that contribute the least in the model) are removed for the next round. When the number of feauture is lower or equal to halve.above, the features are removed one by one. (default=100)}

\item{valid.times}{Integer indicating how many times the training set will be split (default = 10). This number must be smaller than positive and negative sets sizes.}

\item{kernel}{SVM kernel, a character string: "linear" or "radial". (default = "radial")}

\item{cost}{The SVM cost parameter for both linear and radial kernels. If NULL (default), the function \code{mcTune} is run.}

\item{gamma}{The SVM gamma parameter for radial kernel. If radial kernel and NULL (default), the function \code{mcTune} is run.}

\item{numcores}{Number of cores to use for parallel computing (default: the number of available cores in the machine - 1)}

\item{file.prefix}{A character string that will be used as a prefix for output file, if it is NULL (default), no file is writen.}
}
\value{
A 3-columns data frame with ranked features. First column contains the feature names, the second the original position of the feature in the feature.matrix and the third the average rank over the subsets.
}
\description{
The \code{rankFeatures} function  performs a Recursive Feature Elimination (RFE) on subsets of the feature matrix. For each subset the features are ranked according to the weight attributed by SVM at each round of elimination and the average rank of each feature over the subsets is returned. We recommand to save the object containing the ranked features for the following steps.
}
\examples{
data(crm.features)
cost <- 1
gamma <- 1
 #feature.ranking <- rankFeatures(data.granges=crm.features, cost=cost,gamma=gamma,
 #    kernel='linear', file.prefix = "test", halve.above=10)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mcTune.R
\name{mcTune}
\alias{mcTune}
\title{Tuning the SVM parameters}
\usage{
mcTune(data, cl = 1, ranges = list(gamma = c(1, 10), cost = c(1, 10)),
  kernel = "linear", valid.times = 10, file.prefix = NULL,
  numcores = ifelse(.Platform$OS.type == "windows", 1, parallel::detectCores()
  - 1))
}
\arguments{
\item{data}{data.frame containing the training set}

\item{cl}{integer indicating the column number corresponding to the response vector that classify positive and negative regions (default = 1)}

\item{ranges}{list object containing one (linear kernel) or two (radial kernel) vectors of integers corresponding to SVM cost and SVM gamma parameters to test.}

\item{kernel}{SVM kernel, a character string: "linear" or "radial". (default = "radial")}

\item{valid.times}{Integer indicating how many times the training set will be split for the cross validation step (default = 10). This number must be smaller than positive and negative sets sizes.}

\item{file.prefix}{A character string that will be used as a prefix followed by "_c_g_eval.png" for result plot files, if it is NULL (default), no plot is returned}

\item{numcores}{Number of cores to use for parallel computing (default: the number of available cores in the machine - 1)}
}
\value{
A list of class \code{tune}
\item{best.parameters}{A list of the parameters giving the lowest misclassification error}
\item{best.performance}{The lowest misclassification error}
\item{method}{The method used}
\item{nparcomb}{the number of tested parameter combinations}
\item{train.ind}{The indexes used to produce subsets during the cross validation step}
\item{sampling}{The cross-validation fold number}
\item{performances}{A matrix summarizing the cross-validation step with the error for each tested parameter at each round and the dispersion of these errors (regarding to the average error)}
\item{best.model}{The model produced by the best parameters}
}
\description{
The \code{mcTune} function is a modified version of the function \code{tune}  from package e1071  [6]. It tests the different combinations of C and gamma parameters given as vectors in a list and will return the prediction error computed during the cross-validation step.
}
\examples{
data(crm.features)
cost.vector <- c(1,3,10,30)
gamma.vector <- c(1,3,10,30)
#c.g.obj <- mcTune(data.granges= crm.features, ranges = list(cost=cost.vector,
#    gamma=gamma.vector), kernel='linear', file.prefix = "test")
#names(c.g.obj)
# cost <- c.g.obj$best.parameters$cost
# gamma <- c.g.obj$best.parameters$gamma
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mapFeaturesToCRMs.R
\name{mapFeaturesToCRMs}
\alias{mapFeaturesToCRMs}
\title{R interface to bed_to_matrix REST in server}
\usage{

  mapFeaturesToCRMs(URL = "http://ifbprod.aitorgonzalezlab.org/map_features_to_crms.php",
  positive.bed = NULL, genome = NULL, negative.bed = NULL,
  shuffling = NULL, background.seqs = NULL, genome.info = NULL,
  pssm = NULL, background.freqs = NULL, ngs = NULL, bed.overlap = NULL,
  my.values = NULL, feature.ranking = NULL, feature.nb = NULL,
  crm.feature.file = NULL, stderr.log.file = NULL, stdout.log.file = NULL)
}
\arguments{
\item{URL}{URL of the server REST target}

\item{positive.bed}{Positive bed file path. Compulsory}

\item{genome}{Genome code, eg. dm3 for Drosophila Melanogaster. Compulsory}

\item{negative.bed}{Negative bed file path.}

\item{shuffling}{Integer with number of time shuffle background sequences (background.seqs). If negative.bed is NULL and shuffling is set at 0, the feature matrix does not contain negative sequences. It is useful to produce a test set matrix.}

\item{background.seqs}{Background sequences used for shuffling. If shuffling = 0, set this parameter at 0.}

\item{genome.info}{File require for shuffling bed. If shuffling = 0, set this parameter at 0.}

\item{pssm}{Position specific scoring matrices}

\item{background.freqs}{Background frequencies of nucleotides in genome}

\item{ngs}{NGS (bed and wig) files}

\item{bed.overlap}{Minimal overlap as a fraction of query sequence with NGS bed peak. Equivalent with intersectBed -f argument. Default 1bp.}

\item{my.values}{Bed file where fourth column are values to append to the SVM matrix}

\item{feature.ranking}{File with ranked features (Output of rankFeatures). It is used for scoring a query bed file}

\item{feature.nb}{Integer with feature.nb}

\item{crm.feature.file}{Path to feature matrix file}

\item{stderr.log.file}{Path to error log}

\item{stdout.log.file}{Path to standard output log}
}
\value{
A list
\item{feature.matrix}{a data frame where each row is a region and each column a feature, each cell carry a score, the first column is the response vector}
\item{stdout.log}{Standard output log of mapFeaturesToCRMs script in server}
\item{stderr.log}{Standard error log of mapFeaturesToCRMs script in server}
}
\description{
The \code{mapFeaturesToCRMs} function allows the user to create a training set matrix to build a predictive model. The training set is composed of positive regions (known to be involved in the pathway of interest) and negative regions (randomly picked or known to not be involved in the pathway of interest) that will be described (scored) by features. Three types of features file format are accepted: Position specific scoring matrices modeling motifs recognised by transcription factors, bed files containing region coordinates for any discrete feature (NGS peaks, conservation blocks) and wig/bigWig files containing signal data. This script has been tested with version 0.99 of the online server. Go here to see current version of the server http://ifbprod.aitorgonzalezlab.org/map_features_to_crms.php
}
\examples{
\dontrun{
 dirPath <- system.file("extdata", package="LedPred")
 file.list <-   list.files(dirPath, full.names=TRUE)
 background.freqs <- file.list[grep("freq", file.list)]
 positive.regions <-  file.list[grep("positive", file.list)]
 negative.regions <-  file.list[grep("negative", file.list)]
 TF.matrices <-  file.list[grep("tf", file.list)]
 ngs.path <- system.file("extdata/ngs", package="LedPred")
 ngs.files=list.files(ngs.path, full.names=TRUE)
 crm.features.list <- mapFeaturesToCRMs(positive.bed=positive.regions,
     negative.bed=negative.regions,  background.freqs=background.freqs,
     pssm=TF.matrices, genome="dm3", ngs=ngs.files,
     crm.feature.file = "crm.features.tab",
     stderr.log.file = "stderr.log", stdout.log.file = "stdout.log")
 names(crm.features.list)
 class(crm.features.list$crm.features)
 crm.features.list$stdout.log
 crm.features.list$stderr.log
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/evaluateModelPerformance.R
\name{evaluateModelPerformance}
\alias{evaluateModelPerformance}
\title{Evaluate model performances}
\usage{
evaluateModelPerformance(data, cl = 1, valid.times = 10,
  feature.ranking = NULL, feature.nb = NULL,
  numcores = ifelse(.Platform$OS.type == "windows", 1, parallel::detectCores()
  - 1), file.prefix = NULL, kernel = "linear", cost = NULL,
  gamma = NULL)
}
\arguments{
\item{data}{data.frame containing the training set}

\item{cl}{integer indicating the column number corresponding to the response vector that classify positive and negative regions (default = 1)}

\item{valid.times}{Integer indicating how many times the training set will be split for the cross validation step (default = 10). This number must be smaller than positive and negative sets sizes.}

\item{feature.ranking}{List of ordered features.}

\item{feature.nb}{the optimal number of feature to use from the list of ordered features.}

\item{numcores}{Number of cores to use for parallel computing (default: the number of available cores in the machine - 1)}

\item{file.prefix}{A character string that will be used as a prefix followed by "_ROCR_perf.png" for the result plot file, if it is NULL (default), no plot is returned}

\item{kernel}{SVM kernel, a character string: "linear" or "radial". (default = "radial")}

\item{cost}{The SVM cost parameter for both linear and radial kernels. If NULL (default), the function \code{mcTune} is run.}

\item{gamma}{The SVM gamma parameter for radial kernel. If radial kernel and NULL (default), the function \code{mcTune} is run.}
}
\value{
A list with two objects.
\item{probs}{The predictions computed by the model for each subset during the cross-validation}
\item{labels}{The actual class for each subset}
}
\description{
\code{evaluateModelPerformance} function computes the precision and recall measures to evaluate the model through cross validation steps using \code{ROCR} package.
}
\examples{
data(crm.features)
data(feature.ranking)
#probs.labels.list <- evaluateModelPerformance(data.granges=crm.features,
#    feature.ranking=feature.ranking, feature.nb=50,
#    file.prefix = "test")
#names(probs.labels.list[[1]])
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scoreData.R
\name{scoreData}
\alias{scoreData}
\title{Predicting new regulatory regions}
\usage{
scoreData(data, ledpred = NULL, model = NULL, score.file = NULL)
}
\arguments{
\item{data}{data.frame containing the test set. This test set must have the same descriptive features as the one that were used to build the model.}

\item{ledpred}{Returned object from the LedPred function}

\item{model}{Returned object of the createModel function}

\item{score.file}{A character string that will be used as the file name for the output file, if it is NULL (default), no file is writen. The output file takes the form of two columns with object names and scores.}
}
\value{
A 2-columns dataframe. First column containg the SVM model prediction probabilities and the second containing the corresponding regions
}
\description{
\code{scoreData} function predict new regulatory regions using SVM model from a test data set
}
\examples{
data(crm.features)
data(svm.model)
#pred.test <- scoreData(data.granges=crm.features, model=svm.model,
# score.file="test_prediction.tab")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ledpred.R
\name{LedPred}
\alias{LedPred}
\title{Creates an SVM model given a feature matrix}
\usage{
LedPred(data = NULL, cl = 1, ranges = list(gamma = c(1, 10), cost = c(1,
  10)), cost = NULL, gamma = NULL, kernel = "linear", valid.times = 10,
  file.prefix = NULL, numcores = ifelse(.Platform$OS.type == "windows", 1,
  parallel::detectCores() - 1), step.nb = 10, halve.above = 100)
}
\arguments{
\item{data}{data.frame containing the training set}

\item{cl}{integer indicating the column number corresponding to the response vector that classify positive and negative regions (default = 1)}

\item{ranges}{list object containing one (linear kernel) or two (radial kernel) vectors of integers corresponding to SVM cost and SVM gamma parameters to test.}

\item{cost}{The SVM cost parameter for both linear and radial kernels. If NULL (default), the function \code{mcTune} is run.}

\item{gamma}{The SVM gamma parameter for radial kernel. If radial kernel and NULL (default), the function \code{mcTune} is run.}

\item{kernel}{SVM kernel, a character string: "linear" or "radial". (default = "radial")}

\item{valid.times}{Integer indicating how many times the training set will be split for the cross validation step (default = 10). This number must be smaller than positive and negative sets sizes.}

\item{file.prefix}{A character string that will be used as a prefix for the result files. If it is NULL (default), no plot is returned}

\item{numcores}{Number of cores to use for parallel computing (default: the number of available cores in the machine - 1)}

\item{step.nb}{Number of features to add at each step (default = 10)}

\item{halve.above}{During RFE, all the features are ranked at the first round and the half lowest ranked features (that contribute the least in the model) are removed for the next round. When the number of feauture is lower or equal to halve.above, the features are removed one by one. (default=100)}
}
\value{
A list of the object produced at each step
\item{best.params}{A list of the parameters giving the lowest misclassification error}
\item{feature.ranking}{List of ordered features from \code{rankFeatures}}
\item{feature.nb}{he optimal number of feature to use from the list of ordered features from \code{tuneFeatureNb}}
\item{model.svm}{The best SVM model \code{createModel}}
\item{probs.label.list}{The cross-validation results from \code{evaluateModelPerformance}}
}
\description{
The \code{LedPred} function computes the best SVM parameters, defines the optimal features for creating the SVM model by running sequentially \code{mcTune},  \code{rankFeatures},  \code{tuneFeatureNb} and  \code{createModel}. The performances of this model are then computed usong \code{evaluateModelPerformance}.
}
\examples{
 data(crm.features)
 #cost_vector <- c(1,3,10)
 #gamma_vector <- c(1,3,10)
 #ledpred.list=LedPred(data.granges=crm.features, cl=1, ranges = list(cost=cost_vector,
 #                          gamma=gamma_vector), kernel="linear", halve.above=50)
 #names(ledpred.list)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tuneFeatureNb.R
\name{tuneFeatureNb}
\alias{tuneFeatureNb}
\title{Selecting the optimal number of features}
\usage{
tuneFeatureNb(data, cl = 1, feature.ranking, step.nb = 10,
  valid.times = 10, cost = NULL, gamma = NULL, kernel = "linear",
  numcores = ifelse(.Platform$OS.type == "windows", 1, parallel::detectCores()
  - 1), file.prefix = NULL)
}
\arguments{
\item{data}{data.frame containing the training set}

\item{cl}{integer indicating the column number corresponding to the response vector that classify positive and negative regions (default = 1)}

\item{feature.ranking}{List of ordered features.}

\item{step.nb}{Number of features to add at each step (default = 10)}

\item{valid.times}{Integer indicating how many times the training set will be split for the cross validation step (default = 10). This number must be smaller than positive and negative sets sizes.}

\item{cost}{The SVM cost parameter for both linear and radial kernels. If NULL (default), the function \code{mcTune} is run.}

\item{gamma}{The SVM gamma parameter for radial kernel. If radial kernel and NULL (default), the function \code{mcTune} is run.}

\item{kernel}{SVM kernel, a character string: "linear" or "radial". (default = "radial")}

\item{numcores}{Number of cores to use for parallel computing (default: the number of available cores in the machine - 1)}

\item{file.prefix}{A character string that will be used as a prefix followed by "_kappa_measures.png" for the result plot file. If it is NULL (default), no plot is returned}
}
\value{
A list with two objects.
\item{performance}{2-columns data frame. first column correspond to the number of tested features, second column contains the corresponding kappa value}
\item{best.feature.nb}{Integer corresponding to the number of features producing the model with the highest kappa value}
}
\description{
\code{tuneFeatureNb} iterates through increasing feature numbers to calculate kappa values which represents the performance of the model computed with the given features.  We recommand to save the object containing the optimal number of features for the following steps.
}
\examples{
data(crm.features)
data(feature.ranking)
cost <- 1
gamma <- 1
 #feature.nb.obj <- tuneFeatureNb(data.granges=crm.features,
 #    feature.ranking=feature.ranking, kernel='linear', cost=cost,gamma=gamma,
 #    file.prefix = "test")
 #names(feature.nb.obj)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Data.R
\docType{data}
\name{crm.features}
\alias{crm.features}
\title{This is data to be included in my package}
\description{
This is data to be included in my package
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/createModel.R
\name{createModel}
\alias{createModel}
\title{Create the model with the optimal features}
\usage{
createModel(data, cl = 1, kernel = "radial", cost = 1, gamma = 1,
  valid.times = 10, feature.ranking = NULL, feature.nb = NULL,
  file.prefix = NULL)
}
\arguments{
\item{data}{data.frame containing the training set}

\item{cl}{integer indicating the column number corresponding to the response vector that classify positive and negative regions (default = 1)}

\item{kernel}{SVM kernel, a character string: "linear" or "radial". (default = "radial")}

\item{cost}{The SVM cost parameter for both linear and radial kernels. If NULL (default), the function \code{mcTune} is run.}

\item{gamma}{The SVM gamma parameter for radial kernel. If radial kernel and NULL (default), the function \code{mcTune} is run.}

\item{valid.times}{Integer indicating how many times the training set will be split for the cross validation step (default = 10). This number must be smaller than positive and negative sets sizes.}

\item{feature.ranking}{List of ordered features.}

\item{feature.nb}{the optimal number of feature to use from the list of ordered features.}

\item{file.prefix}{A character string that will be used as a prefix followed by "_model.RData" for the resulting model file, if it is NULL (default), no model is saved}
}
\value{
the best SVM model
}
\description{
\code{createModel} function creates a SVM model from the training data set with the selected features.
}
\examples{
    data(crm.features)
    cost <- 1
    gamma <- 1
    data(feature.ranking)
    feature.nb <- 70
#svm.model <- createModel(data.granges=crm.features, cost=cost, gamma=gamma,
#    feature.ranking=feature.ranking, feature.nb=feature.nb)
#feature.weights <- as.data.frame(t(t(svm.model$coefs) \%*\% svm.model$SV))
}
